
// Original code:
//   http://www.emit.jp/sha/sha.html

//////////////////////////////////////////////////////////////////////////////
// General Function Library  Copyright (C) 2000 SYN All Rights Reserved.
//////////////////////////////////////////////////////////////////////////////
#ifndef __SYN_GflSHA_h__
#define __SYN_GflSHA_h__

// wb_ƃCu
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

// STL֌W
#pragma warning(disable:4786)
#include <string>
using namespace std;

#define SHA_HASH  5
#define SHA_BLOCK 16
#define SHA_WORK  80
#define SHA_BUFFER_SIZE (SHA_BLOCK * 4)

class GflSHA1{
private:
	DWORD m_dwH[SHA_HASH];
	DWORD m_dwLNumBits;
	DWORD m_dwHNumBits;
	DWORD m_aBlock[SHA_BLOCK];
	int   m_nNumChr;
private:
	void Generate(void);
protected:
	DWORD ReverseEndian(DWORD dwValue) { return (dwValue << 24) | ((dwValue & 0x0000ff00) << 8) | ((dwValue & 0x00ff0000) >> 8) | (dwValue >> 24); }
	DWORD Rotate(DWORD dwValue, DWORD dwNum) { return (dwValue << dwNum) | (dwValue >> (32 - dwNum)); }
public:
	void Init(void);
	void Load(const BYTE *pBuffer, DWORD dwSize);
	void Final(void);
	string GetDigest(void);
public:
	GflSHA1();
	~GflSHA1();
};


// ------------------
// SHA-256
// ------------------

//////////////////////////////////////////////////////////////////////////////
// General Function Library  Copyright (C) 2000,2001 SYN All Rights Reserved.
//////////////////////////////////////////////////////////////////////////////

/* COMMENT OUT by mey
// wb_ƃCu
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

// STL֌W
#pragma warning(disable:4786)
#include <string>
using namespace std;
*/


#define SHA256_HASH   8
#define SHA256_BLOCK 16
#define SHA256_WORK  64
#define SHA256_BUFFER_SIZE (SHA256_BLOCK * 4)

class GflSHA256{
protected:
	DWORD m_dwH[SHA256_HASH];
	DWORD m_dwLNumBits;
	DWORD m_dwHNumBits;
	DWORD m_aBlock[SHA256_BLOCK];
	int   m_nNumChr;
protected:
	void Generate(void);
	inline DWORD ReverseEndian(DWORD x) {return (x << 24) | ((x & 0x0000ff00) << 8) | ((x & 0x00ff0000) >> 8) | (x >> 24);}
	inline DWORD Rotate(DWORD x, DWORD n) {return (x >> n) | (x << (32 - n));}
	inline DWORD Ch(DWORD x, DWORD y, DWORD z) {return (x & (y ^ z)) ^ z;}
	inline DWORD Maj(DWORD x, DWORD y, DWORD z) {return (x & (y | z)) | (y & z);}
	inline DWORD S0(DWORD x) {return Rotate(x,  2) ^ Rotate(x, 13) ^ Rotate(x, 22);}
	inline DWORD S1(DWORD x) {return Rotate(x,  6) ^ Rotate(x, 11) ^ Rotate(x, 25);}
	inline DWORD s0(DWORD x) {return Rotate(x,  7) ^ Rotate(x, 18) ^ (x >> 3);}
	inline DWORD s1(DWORD x) {return Rotate(x, 17) ^ Rotate(x, 19) ^ (x >> 10);}
public:
	GflSHA256(void);
	virtual ~GflSHA256(void);
public:
	virtual void Init(void);
	virtual void Load(const BYTE *pBuffer, DWORD dwSize);
	virtual void Final(void);
	virtual string GetDigest(void);
};


#endif  __SYN_GflSHA1_h__
