#ifndef _TVP_PLUGIN_COMMON_H_
#define _TVP_PLUGIN_COMMON_H_

#include <windows.h>
#include "tp_stub.h"
#include "TPRevision.h"
#include "TPMessage.h"

#define TPFUNCCALL 
#define TPFASTCALL __fastcall


// ėp
#define BEGIN_CLASSDEF(_this) \
class _this \
{ \
typedef _this thisclass;

// PpNX
#define BEGIN_CLASSDEF_INHERIT(_this,_super) \
class _this : public _super \
{ \
typedef _this thisclass; \
typedef _super inherited;

// dpNX
#define BEGIN_CLASSDEF_INHERIT2(_this,_super1,_super2) \
class _this : public _super1, public _super2 \
{ \
typedef _this thisclass; \
typedef _super1 inherited1; \
typedef _super2 inherited2;

#define END_CLASSDEF };

// ϊ
#define TP_DUMP_STR_LOCALE      0	// [JɈˑϊiWindowsȂShift_JISj
#define TP_DUMP_ENDIAN_PLATFORM 1	// vbgtH[ɏ]
#define TP_DUMP_ENDIAN_LITTLE   2	// gGfBAɕϊ
#define TP_DUMP_ENDIAN_BIG      3	// rbOGfBAɕϊ


// FuncCall()ŗLpȁiHj}NW 

// ̃p[^CfbNXϐ __tp_param_idx Iɒ`B
// ̓}NŎQƁ^XV̂łāA
// vO}̕ϐQƂ͍̂D܂ȂB
// XVȂǂĂ̂قłB


// check parameter type
#define TP_COND_PARAM_IS_VOID (__tp_param[__tp_param_idx]->Type() == tvtVoid)
#define TP_COND_PARAM_IS_STR  (__tp_param[__tp_param_idx]->Type() == tvtString)
#define TP_COND_PARAM_IS_OCT  (__tp_param[__tp_param_idx]->Type() == tvtOctet)
#define TP_COND_PARAM_IS_OBJ  (__tp_param[__tp_param_idx]->Type() == tvtObject)
#define TP_COND_PARAM_IS_INSTANCE_OF(_cls) (TP_COND_PARAM_IS_OBJ && isObjectInstanceOf(__tp_param[__tp_param_idx], TJS_W(#_cls)))
#define TP_COND_PARAM_IS_NULL (TP_COND_PARAM_IS_OBJ && isNullObject(__tp_param[__tp_param_idx]))

#define TP_COND_PARAM_IS_VALID ((numparams > __tp_param_idx) && __tp_param[__tp_param_idx] && __tp_param[__tp_param_idx]->Type() != tvtVoid)

#ifdef TP_ENABLE_DEPRECATED
#  include "tp_deprecated.h"
#endif

// FuncCall()ŗLpȁiHj}NW ܂



// func call
#define TVP_PLUGIN_TJSDISPATCH2_FUNCCALL_CALLIMPL(_obj, _cls, _name, _hint, _result, _nump, _pval, _caller) \
	{ \
		tjs_error __error_code = _obj->FuncCall(0, TJS_W(#_name), _hint, _result, _nump, _pval, _obj); \
		if (TJS_FAILED(__error_code)) { \
			TP_ThrowMes(TJSEM_E_FUNCCALL_FAIL, _caller, TJS_W(#_cls) TJS_W(".") TJS_W(#_name)); \
		} \
	}

// get by num
#define TVP_PLUGIN_TJSDISPATCH2_PROPGETBYNUM_CALL_IMPL(_obj, _cls, _id, _pval, _caller) \
	{ \
		tjs_error __error_code = _obj->PropGetByNum(TJS_MEMBERMUSTEXIST, (_id), _pval, _obj); \
		if (TJS_FAILED(__error_code)) { \
			TP_ThrowMes(TJSEM_E_PROPGETBYNUM_FAIL, _caller, TJS_W(#_cls), (ttstr)(_id)); \
		} \
	}

// get by name
#define TVP_PLUGIN_TJSDISPATCH2_PROPGET_CALLIMPL(_obj, _cls, _name, _hint, _val, _caller) \
	{ \
		tjs_error __error_code = _obj->PropGet(TJS_MEMBERMUSTEXIST, TJS_W(#_name), _hint, _val, _obj); \
		if (TJS_FAILED(__error_code)) { \
			TP_ThrowMes(TJSEM_E_PROPGETBYNUM_FAIL, _caller, TJS_W(#_cls) TJS_W(".") TJS_W(#_name)); \
		} \
	}


// is null?
bool isNullObject(tTJSVariant * obj);
bool isNullObject(tTJSVariantClosure * obj);

// instanceof Zq
bool isObjectInstanceOf(iTJSDispatch2 * obj, const tjs_char * name);
bool isObjectInstanceOf(const tTJSVariantClosure * obj, const tjs_char * name);
bool isObjectInstanceOf(const tTJSVariant * var, const tjs_char * name);

// Array Util.
void Array_CreateObject(tTJSVariant * result);
tjs_int Array_PropGet_count(iTJSDispatch2 * obj, const tjs_char * memberName);
tjs_int Array_PropGet_count(iTJSDispatch2 * obj);
void Array_FuncCall_assign(iTJSDispatch2 * src, iTJSDispatch2 * dest);
void Array_FuncCall_assign(iTJSDispatch2 * src, iTJSDispatch2 * dest, const tjs_char * memberName);
void Array_FuncCall_erase(iTJSDispatch2 * src, tjs_int idx);
void Array_FuncCall_erase(iTJSDispatch2 * src, tjs_int idx, const tjs_char * memberName);
void Array_FuncCall_add(iTJSDispatch2 * src, tTJSVariant * obj);
void Array_FuncCall_add(iTJSDispatch2 * src, tTJSVariant * obj, const tjs_char * memberName);
void Array_FuncCall_clear(iTJSDispatch2 * src);
void Array_FuncCall_clear(iTJSDispatch2 * src, const tjs_char * memberName);

// QƂԂB
const iTJSDispatch2 * Array_PropGetByNumAsObject(iTJSDispatch2 * obj, tjs_int num);
const iTJSDispatch2 * Array_PropGetByNumAsObject(iTJSDispatch2 * obj, tjs_int num, const tjs_char * memberName);
const tTJSVariant & Array_PropGetByNumAsVariant(iTJSDispatch2 * obj, tjs_int num);
const tTJSVariant & Array_PropGetByNumAsVariant(iTJSDispatch2 * obj, tjs_int num, const tjs_char * memberName);

// X,Y C^[[u
void Array_deinterleaveXY(iTJSDispatch2 * path, tjs_int arraysize, tjs_int * x, tjs_int * y);
void Array_deinterleaveXY(iTJSDispatch2 * path, tjs_int arraysize, tjs_real * x, tjs_real * y);

// Oo
void TP_AddLog(const tjs_char * msg, const tjs_char * memberName);
void TP_AddLog(const tjs_char * msg, const tjs_char * memberName, const ttstr & param1);
void TP_AddLog(const tjs_char * msg, const tjs_char * memberName, const ttstr & param1, const ttstr & param2);

// ObZ[W𓊂
void TP_ThrowMes(const tjs_char * msg, const tjs_char * memberName);
void TP_ThrowMes(const tjs_char * msg, const tjs_char * memberName, const ttstr & param1);
void TP_ThrowMes(const tjs_char * msg, const tjs_char * memberName, const ttstr & param1, const ttstr & param2);

// ^
const ttstr & TP_GetVariantTypeName(const tTJSVariant * variant);
const ttstr & TP_GetVariantTypeName(const tTJSVariant & variant);
const ttstr & TP_GetVariantTypeName(tTJSVariantType type);


// O[o萔
void TP_AddConstRegisterExpression(ttstr & expression, const ttstr & name, tjs_int value);
void TP_AddConstDeleteExpression(ttstr & expression, const ttstr & name);


// lCeBuNX
#include "tjse_ncdecl.h"

// INebg
tTJSVariantOctet * AllocVariantOctetFromString(ttstr & workstr, tjs_int mode, const wchar_t * __tp_member_name);




#endif _TVP_PLUGIN_COMMON_H_
