#include "TableHolder.h"

// e[u쐬
void CTableHolder::createTable(tjs_int num, tjs_int sinacc)
{
	this->clear();
	this->angle_accuracy = num;
	this->sin_accuracy = sinacc;

	arctan_table = new tjs_int[num];
	sin_table = new tjs_int[num];
	cos_table = new tjs_int[num];
	tan_table = new tjs_int[num];

	createArctanTable();
	createSinTable();
	createCosTable();
	createTanTable();
}


// tڃe[u쐬
void CTableHolder::createArctanTable()
{
	tjs_int num = this->angle_accuracy;
	tjs_real *temp_table = new tjs_real[num];

	tjs_int div4 = num / 8;	// /4 ɑ
	tjs_int i, idx;

	for (i = 0; i < num; i++) {
		arctan_table[i] = num - i;
	}

	//یi^ʖڂɌvZj
	temp_table[0] = 0.0;
	for (i = 1; i < div4; i++) {
		tjs_real ratio = (tjs_real)i / (tjs_real)div4;
		idx = i + 0 * div4;
		temp_table[idx] = ::atan(ratio);
	}

	temp_table[div4] = M_PI_4;
	for (i = 1; i < div4; i++) {
		tjs_real ratio = (tjs_real)div4 / (tjs_real)(div4 - i);
		idx = i + 1 * div4;
		temp_table[idx] = ::atan(ratio);
	}

	//یi^ʖڂɌvZj
	temp_table[2 * div4] = M_PI_2;
	for (i = 1; i < div4; i++) {
		tjs_real ratio = (tjs_real)div4 / (tjs_real)i;
		idx = i + 2 * div4;
		temp_table[idx] = -::atan(ratio) + M_PI;
	}

	temp_table[3 * div4] = 3.0 * M_PI_4;
	for (i = 1; i < div4; i++) {
		tjs_real ratio = (tjs_real)(div4 - i) / (tjs_real)div4;
		idx = i + 3 * div4;
		temp_table[idx] = -::atan(ratio) + M_PI;
	}

	//Oیlیi͎蔲[hj
	for (i = 0; i < (4 * div4); i++) {
		idx = i + 4 * div4;
		temp_table[idx] = temp_table[i] + M_PI;
	}

	//܂Ƃ߂
	for (i = 0; i < num; i++) {
		arctan_table[i] = (tjs_int)((tjs_real)num * temp_table[i] / (2.0 * M_PI));
	}

	delete[] temp_table;
}

// e[u쐬
void CTableHolder::createSinTable()
{
	tjs_int i;
	for (i = 0; i < angle_accuracy; i++) {
		tjs_real theta = 2.0 * M_PI * (tjs_real)i / (tjs_real)angle_accuracy;
		sin_table[i] = (tjs_real)sin_accuracy * ::sin(theta);
		cos_table[i] = (tjs_real)sin_accuracy * ::cos(theta);
		tan_table[i] = 0;
	}
}



// tڃe[ũCfbNXl
tjs_int CTableHolder::getAtanIndex(tjs_int x, tjs_int y) const
{
	tjs_int N = this->angle_accuracy;
	tjs_int Nbase = N / 8;
	// Βl
	tjs_int abs_x = INT_ABS(x);
	tjs_int abs_y = INT_ABS(y);
	// ߂l
	tjs_int m;

	// Y
	if (abs_x == 0) {
		m = (y >= 0) ? 2*Nbase : 6*Nbase;
	// X
	} else if (abs_y == 0) {
		m = (x >= 0) ? 0 : 4*Nbase;
	} else {
		m = (abs_x > abs_y) ?
			((Nbase * abs_y) / abs_x) :
			((2 * Nbase) - (Nbase * abs_x) / abs_y);
		//AOAlی̃P[XɓKp
		if (x > 0) {
			m = (y > 0) ? m : ((N - m) % N);
		} else {
			m = (y > 0) ? (4*Nbase - m) : (4*Nbase + m);
		}
	}

	return m;
}


tjs_int CTableHolder::getDistance(tjs_int x, tjs_int y) const
{
	tjs_int rv = 0;
	if (x < 0) x = -x;
	if (y < 0) y = -y;
	if (x && y) {
		tjs_int atan = this->arctan(x, y);
		tjs_int cos = this->cos(atan);
		rv = (cos) ? (this->getSinAccuracy() * x / cos) : y;
	} else {
		rv = x ? x : y;
	}
	return rv;
}


// NA
void CTableHolder::clear()
{
	if (arctan_table != NULL) {
		delete[] arctan_table;
	}
	if (tan_table != NULL) {
		delete[] tan_table;
	}
	if (sin_table != NULL) {
		delete[] sin_table;
	}
	if (cos_table != NULL) {
		delete[] cos_table;
	}
}


