#ifndef _TJSE_NC_DECL_H_
#define _TJSE_NC_DECL_H_
//--------------------------------------------------------------
// 
//--------------------------------------------------------------

// lCeBuCX^X
#define TJSE_NI_CLASS_NAME(_name) tjse_NativeInstanceClass_##_name
// lCeBuNX
#define TJSE_NC_CLASS_NAME(_name) tjse_NativeClassClass_##_name

// lCeBuCX^XNXID
#define TJSE_NI_CLASS_ID(_name) ClassID_tjse_NativeInstanceClass_##_name


//---------------------------------------------------------------------------
// lCeBu֐`Jn
#define TJSE_NATIVE_FUNCTION_DECL_BEGIN(_name) \
class tjse_NativeFunctionClass_##_name : public tTJSNativeFunction \
{ \
public: \
	tjs_error Process(tTJSVariant *result, tjs_int numparams, \
		tTJSVariant **param, iTJSDispatch2 *objthis) \
	{ \

// lCeBu֐`I
#define TJSE_NATIVE_FUNCTION_DECL_END \
	} \
};
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------

// lCeBuCX^X`Jn
#define TJSE_NATIVE_INSTANCE_DECL_BEGIN(_name) \
class TJSE_NI_CLASS_NAME(_name) : public tTJSNativeInstance \
{

// lCeBuCX^X`Jnidpj
#define TJSE_NATIVE_INSTANCE_DECL_BEGIN_INHERIT(_name, _super1) \
class TJSE_NI_CLASS_NAME(_name) : public tTJSNativeInstance, public _super1 \
{ \
	typedef _super1 _super;

// lCeBuCX^X`I
#define TJSE_NATIVE_INSTANCE_DECL_END };

// lCeBũRXgN^`
#define TJSE_NI_CONSTRUCTOR(_name) TJSE_NI_CLASS_NAME(_name)()

#define TJSE_NI_DESTRUCTOR(_name) ~tjse_NativeInstanceClass_##_name()

// TJS̃RXgN^`
#define TJSE_TJS_CONSTRUCTOR_DECL \
tjs_error TJS_INTF_METHOD Construct(tjs_int numparams, tTJSVariant ** param, iTJSDispatch2 * tjs_obj)

// TJS̃RXgN^`ij
#define TJSE_TJS_CONSTRUCTOR_IMPL(_cls) \
tjs_error TJS_INTF_METHOD TJSE_NI_CLASS_NAME(_cls)::Construct(tjs_int numparams, tTJSVariant ** param, iTJSDispatch2 * tjs_obj)

// TJS̋̃RXgN^`
#define TJSE_TJS_EMPTY_CONSTRUCTOR_DECL \
tjs_error TJS_INTF_METHOD Construct(tjs_int numparams, tTJSVariant ** param, iTJSDispatch2 * tjs_obj) \
{ return TJS_S_OK; }

// TJS̋̃fXgN^`
#define TJSE_TJS_EMPTY_DESTRUCTOR_DECL \
void TJS_INTF_METHOD Invalidate() {}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// lCeBu֐o^
#define TJSE_NATIVE_FUNCTION_REGISTER(_name) \
{ \
	iTJSDispatch2 * global = TJSEGetGlobalObject(); \
	iTJSDispatch2 * func = new tjse_NativeFunctionClass_##_name(); \
	tTJSVariant func_var(func); \
	func->Release(); \
	TJS_THROW_IF_ERROR(global->PropSet(TJS_MEMBERENSURE, TJS_W(#_name), NULL, &func_var, NULL)); \
}

// lCeBuNXo^
#define TJSE_NATIVE_CLASS_REGISTER(_name) \
{ \
	iTJSDispatch2 * global = TJSEGetGlobalObject(); \
	iTJSDispatch2 * cls = new TJSE_NC_CLASS_NAME(_name)(); \
	tTJSVariant cls_var(cls); \
	cls->Release(); \
	TJS_THROW_IF_ERROR(global->PropSet(TJS_MEMBERENSURE|TJS_IGNOREPROP, TJS_W(#_name), NULL, &cls_var, global)); \
}
//---------------------------------------------------------------------------

// lCeBuNX錾
#define TJSE_NATIVE_CLASS_CLASS_DECL(_name) \
class TJSE_NC_CLASS_NAME(_name) : public tTJSNativeClass \
{ \
	typedef tTJSNativeClass inherited; \
public: \
	TJSE_NC_CLASS_NAME(_name)(); \
	static tjs_uint32 ClassID; \
protected: \
	tTJSNativeInstance * CreateNativeInstance(); \
};


// TVP Plugin?
#ifdef __TP_STUB_H__
#define F__THROW_EXCEPT(_msg, _func) TP_ThrowMes(_msg, _func)

#define TJSE_GET_NI_FROM_CLOSURE(_cls, _closure, _ni, _func) \
	if (_closure.Object) { \
		if (TJS_FAILED(_closure.Object->NativeInstanceSupport( \
			TJS_NIS_GETINSTANCE,  \
			TJSE_NI_CLASS_ID(_cls), \
			(iTJSNativeInstance**)&_ni))) \
			TP_ThrowMes(TJSEM_E_GET_NI_FAIL, _func); \
	} \
	if (!_ni) TP_ThrowMes(TJSEM_E_GET_NI_FAIL, _func);

#define TJSE_GET_NI_FROM_DISPATCH(_cls, _dis, _ni, _func) \
	if (_dis) { \
		if (TJS_FAILED(_dis->NativeInstanceSupport( \
			TJS_NIS_GETINSTANCE,  \
			TJSE_NI_CLASS_ID(_cls), \
			(iTJSNativeInstance**)&_ni))) \
			TP_ThrowMes(TJSEM_E_GET_NI_FAIL, _func); \
	} \
	if (!_ni) TP_ThrowMes(TJSEM_E_GET_NI_FAIL, _func);

// TJSE?
#else
#define F__THROW_EXCEPT(_msg) TJSEThrowExceptionMessage(_msg)

#define TJSE_GET_NI_FROM_CLOSURE(_cls, _closure, _ni, _msg) \
	if (_closure.Object) { \
		if (TJS_FAILED(_closure.Object->NativeInstanceSupport( \
			TJS_NIS_GETINSTANCE,  \
			TJSE_NC_CLASS_NAME(_cls)::ClassID,  \
			(iTJSNativeInstance**)&_ni))) \
			F__THROW_EXCEPT(_msg); \
	} \
	if (!_ni) F__THROW_EXCEPT(_msg);

#define TJSE_GET_NI_FROM_DISPATCH(_cls, _dis, _ni, _msg) \
	if (_dis) { \
		if (TJS_FAILED(_dis->NativeInstanceSupport( \
			TJS_NIS_GETINSTANCE,  \
			TJSE_NC_CLASS_NAME(_cls)::ClassID,  \
			(iTJSNativeInstance**)&_ni))) \
			F__THROW_EXCEPT(_msg); \
	} \
	if (!_ni) F__THROW_EXCEPT(_msg);

#endif



//--------------------------------------------------------------
#endif  _TJSE_NC_DECL_H_


