#include "GradationFunc.h"
#include "GraphFunc.h"
#include "TPGraphic.h"
#include "LayerBufferImpl.h"
#include "TableHolder.h"

#include <math.h>


// e[uz_[
extern CTableHolder * TableHolder;

template <typename T>
static void TPFASTCALL reverseArray(T * dest, tjs_int num)
{
	const tjs_int nh = num / 2;

	for (tjs_int i = 0; i < nh; i++) {
		T tmp;
		SWAP_INT(dest[i], dest[num - i - 1], tmp);
	}

	return;
}



/*
Of[V֘A

R[ꍇ́A
Ecols ͔NULLł邱
EnumCols 2ȏł邱
AĂяomF邱ƁB
LȂꍇ͕̓ۏ؂ȂB
*/


#define TVP_RGB2COLOR_FPN(r,g,b) (((r) & 0xff0000) | (((g) & 0xff0000) >> 8) | (((b) & 0xff0000) >> 16) | 0xff00000000)

#define TVP_ARGB2COLOR_FPN(r,g,b,a) (((r) & 0xff0000) | (((g) & 0xff0000) >> 8) | (((b) & 0xff0000) >> 16) | (a << 24))

// RGBo
#define F__DEF_RGB_CODE \
	tjs_int g1R = (col1 & 0xFF0000) >> 16; \
	tjs_int g2R = (col2 & 0xFF0000) >> 16; \
	tjs_int g1G = (col1 & 0xFF00) >> 8; \
	tjs_int g2G = (col2 & 0xFF00) >> 8; \
	tjs_int g1B = col1 & 0xFF; \
	tjs_int g2B = col2 & 0xFF;

// QlԂ̍
#define F__DEF_BETWEEN_2COLORS \
	tjs_int diffR = g2R - g1R; \
	tjs_int diffG = g2G - g1G; \
	tjs_int diffB = g2B - g1B;


/*
}`Of[Vp^[z쐬
*/
static bool TPFUNCCALL makeMultiGradationPattern(
	const tjs_uint32 * cols, 
	tjs_int numCols, 
	tjs_uint32 * dest, 
	tjs_int destSize,
	tjs_uint32 opa = 255)
{
	if (numCols < 2) return false;
	if (destSize < 1) return false;

//	tjs_int cnt = 0x8000;	// 1.15.16 signed fixed point number
	tjs_int gstep = (destSize << 16) / (numCols - 1);	// 1.15.16 signed fixed point number
	tjs_int totalgstep = 0x8000;	// 1.15.16 signed fixed point number

	for (tjs_int i = 0; i < numCols - 1; i++) {
		tjs_int w = ((totalgstep + gstep) >> 16) - (totalgstep >> 16);
		totalgstep += gstep;

		if (w > 0) {
			const tjs_uint32 col1 = cols[i];
			const tjs_uint32 col2 = cols[i+1];

			// RGBo (1.15.16)
			tjs_int g1R = col1 & 0xFF0000;
			tjs_int g2R = col2 & 0xFF0000;
			tjs_int g1G = (col1 & 0xFF00) << 8;
			tjs_int g2G = (col2 & 0xFF00) << 8;
			tjs_int g1B = (col1 & 0xFF)   << 16;
			tjs_int g2B = (col2 & 0xFF)   << 16;

			// 1sNZ
			tjs_int diffR = (g2R - g1R) / w;
			tjs_int diffG = (g2G - g1G) / w;
			tjs_int diffB = (g2B - g1B) / w;

			for (tjs_int i = 0; i < w; i++) {
				*dest++ = TVP_ARGB2COLOR_FPN(g1R, g1G, g1B, opa);
				g1R += diffR;
				g1G += diffG;
				g1B += diffB;
			}
		}
	}

	return true;
}


#define CALL_MAKE_MULTI_GRAD_PAT(_cols, _numCols, _src, _w, _opa) \
	try { \
		makeMultiGradationPattern(_cols, _numCols, _src, _w, _opa); \
	} catch (...) { \
		delete[] _src; \
		throw; \
	}


// Of[V`ileft to rightj
static tjs_int TPFUNCCALL Layer_drawGradatedColorRectImpl_L2R(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int w,
	tjs_int h,
	tjs_uint32 * cols,
	tjs_int numCols,
	tjs_int opa)
{
	tjs_int rv = 0;
	const tTVPRect * const draw = layer->drawRect;
	const tjs_int face = layer->face;

	// Ή`惂[h
	if (face == dfMask || face == dfProvince) return -1;

	// `捂
	tjs_int ty1 = (y < draw->top) ? draw->top : y;	// updatë
	tjs_int ty2 = (y + h - 1 > draw->bottom) ? draw->bottom : (y + h - 1);
	tjs_int sh = ty2 - ty1 + 1;	// updatë

	if (sh <= 0) return 0;

	// Of[Vp^[
	tjs_uint32 * src = new tjs_uint32[w];
	makeMultiGradationPattern(cols, numCols, src, w, opa);

	try {
		// XLCRs[
		for (tjs_int py = ty1; py <= ty2; py++) {
			rv += Layer_copyHorizontalLineImpl(layer, x, py, w, src, opa);
		}
	} catch (...) {
		delete[] src;
		throw;
	}

	delete[] src;

	// update
	if (rv > 0) {
		tjs_int tx1 = (x < draw->left) ? draw->left : x;	// updatë
		tjs_int tx2 = (x + w - 1 > draw->right) ? draw->right : (x + w - 1);
		tjs_int sw = tx2 - tx1 + 1;	// updatë
		Layer_FuncCall_update(layer, tx1, ty1, sw, sh);
	}

	return rv;
}


// Of[V`itop to bottomj
static tjs_int TPFUNCCALL Layer_drawGradatedColorRectImpl_T2B(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int w,
	tjs_int h,
	tjs_uint32 * cols,
	tjs_int numCols,
	tjs_int opa)
{
	const tTVPRect * const draw = layer->drawRect;
	tjs_int rv = 0;

	// Of[Vp^[obt@쐬
	tjs_uint32 * src = new tjs_uint32[h];
	CALL_MAKE_MULTI_GRAD_PAT(cols, numCols, src, h, opa)

	try {
		for (tjs_int i = 0; i < h; i++) {
			tjs_uint32 col = src[i];
			tjs_int trv = Layer_drawHorizontalLineImpl(layer, x, y + i, w, col, opa);
			F__CHECK_HL_IMPL_RESULT_BREAK(trv, rv)
		}
	} catch (...) {
		delete[] src;
		throw;
	}


	delete[] src;

	// update
	if (rv > 0) {
		Layer_FuncCall_update(layer, x, y, w, h);
	}

	return rv;
}


// Of[V`iSpecifiedj
static tjs_int TPFUNCCALL Layer_drawGradatedColorRectImpl_Specified(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int w,
	tjs_int h,
	tjs_real fdir,
	tjs_uint32 * cols,
	tjs_int numCols,
	tjs_int opa)
{
	tjs_int rv = 0;

	// C
	const tTVPRect * const draw = layer->drawRect;
	const bool withOpa = (opa < 255);
	const tjs_int face = layer->face;

	const CTableHolder * const table = TableHolder;
	const tjs_int angleAcc = table->getAccuracy();
	const tjs_int sinAcc = table->getSinAccuracy();

	tjs_int dir = 0;	// angle
	if (fdir != 0) dir = angleAcc * fdir / (2.0 * 3.1415926536);

	// px̐K
	if (fdir < 0) dir = -dir;
	dir %= angleAcc;
	if (fdir < 0) dir = angleAcc - dir;

	tjs_int cosTheta = table->cos(dir);
	tjs_int sinTheta = table->sin(dir);

	// P[X
	// とis Of[V
	if (cosTheta == 0) {
		// /2
		if (sinTheta >= 0) {
			// nothing to do
		// 3/2
		} else {
			reverseArray<tjs_uint32>(cols, numCols);
		}
		rv = Layer_drawGradatedColorRectImpl_T2B(layer, x, y, w, h, cols, numCols, opa);
		return rv;

	// Eis Of[V
	} else if (sinTheta == 0) {
		// 0
		if (cosTheta >= 0) {
			// nothing to do
		// 
		} else {
			reverseArray<tjs_uint32>(cols, numCols);
		}
		rv = Layer_drawGradatedColorRectImpl_L2R(layer, x, y, w, h, cols, numCols, opa);

		return rv;
	}

	// 0 ` /2A3/2 ` 2 ɐK
	if (cosTheta < 0) {
		tjs_uint32 tmp;
		if (sinTheta >= 0) {
			dir += angleAcc / 2;
		} else {
			dir -= angleAcc / 2;
		}
		reverseArray<tjs_uint32>(cols, numCols);
		// 蒼
		cosTheta = table->cos(dir);
		sinTheta = table->sin(dir);
	}

	// Of[Vp^[obt@쐬
	const tjs_int bufferLen = 256 * (numCols - 1);
	tjs_uint32 * src = new tjs_uint32[bufferLen];
	CALL_MAKE_MULTI_GRAD_PAT(cols, numCols, src, bufferLen, opa)

	// src̊Jnʒu
	tjs_int srcstart = 0;

	// X^XLJnʒu
	tjs_int px = x;
	tjs_int py;

	tjs_int slant;
	tjs_int startstep;

	// ی
	if (sinTheta >= 0) {
		slant = w * cosTheta + h * sinTheta;
		startstep = bufferLen * ((sinTheta << 16) / slant);
	// lی
	} else {
		slant = w * cosTheta - h * sinTheta;
		startstep = bufferLen * ((-sinTheta << 16) / slant);
	}
	tjs_int srcstep = bufferLen * ((cosTheta << 16) / slant);

	// Nbv̈̍ɂ͂ݏoꍇ
	if (x < draw->left) {
		px = draw->left;
		// Jnʒu炷
		srcstart = srcstep * (draw->left - x);
	}

	// `敝
	tjs_int tx1 = (x < draw->left) ? draw->left : x;	// updatë
	tjs_int tx2 = (x + w - 1 > draw->right) ? draw->right : (x + w - 1);
	tjs_int sw = tx2 - tx1 + 1;	// updatë

	// `捂
	tjs_int ty1 = (y < draw->top) ? draw->top : y;	// updatë
	tjs_int ty2 = (y + h - 1 > draw->bottom) ? draw->bottom : (y + h - 1);
	tjs_int sh = ty2 - ty1 + 1;	// updatë

	// `KvȂH
	if (sw <= 0 || sh <= 0) return 0;

	// cis
	tjs_int vstep = 1;
	// ی
	if (sinTheta >= 0) {
		py = ty1;
		// ɂ͂ݏoꍇ
		if (y < draw->top) {
			srcstart += startstep * (draw->top - y);
		}
	// lی
	} else {
		// ㉺tɐis
		py = ty2;
		vstep = -1;

		// ɂ͂ݏoꍇ
		if (y + h >= draw->bottom) {
			srcstart += startstep * (y + h - draw->bottom);
		}
	}

// XLCRs[
// ijuBCC warning: W8060 : 炭sȑvȂłB
#define F__ITERATE_Y_SCANLINE_COPY_IMPL_P5(func) { \
	for (tjs_int i = 0; i < sh; i++) { \
		tjs_uint32 * p = layer->getBufferPtr(px, py); \
		func (p, sw, src, srcstart, srcstep); \
		py += vstep; \
		srcstart += startstep; \
		rv += sw; \
	} \
}

#define F__ITERATE_Y_SCANLINE_COPY_IMPL_P6(func) { \
	for (tjs_int i = 0; i < sh; i++) { \
		tjs_uint32 * p = layer->getBufferPtr(px, py); \
		func (p, sw, src, srcstart, srcstep, opa); \
		py += vstep; \
		srcstart += startstep; \
		rv += sw; \
	} \
}

	try {
		switch (face) {
		case dfAlpha: // main and mask ( == dfBoth )
			if (withOpa) {
				F__ITERATE_Y_SCANLINE_COPY_IMPL_P6(TVPStretchConstAlphaBlend_d);
			} else {
				F__ITERATE_Y_SCANLINE_COPY_IMPL_P5(TVPStretchCopy);
			}
			// sx(RemoveConstOpacity)ɂ͖Ή
			break;

		case dfAddAlpha: // additive alpha; main and mask
			if (withOpa) {
				F__ITERATE_Y_SCANLINE_COPY_IMPL_P6(TVPStretchConstAlphaBlend_a);
			} else {
				F__ITERATE_Y_SCANLINE_COPY_IMPL_P5(TVPStretchCopy);
			}
			break;

		case dfOpaque: // main only
			if (withOpa) {
				F__ITERATE_Y_SCANLINE_COPY_IMPL_P6(TVPStretchConstAlphaBlend);
			} else {
				F__ITERATE_Y_SCANLINE_COPY_IMPL_P5(TVPStretchColorCopy);
			}
			break;

		case dfMask: // mask ( opacity will be ignored )
			// Ă܂B
			// [A}XNŃOf[VH
			rv = -1;
			break;

		case dfProvince: // province ( opacity will be ignored )
		default:
			// Ă܂B
			rv = -1;
			break;

		}
	} catch (...) {
		delete[] src;
		throw;
	}

#undef F__ITERATE_Y_SCANLINE_COPY_IMPL_P5
#undef F__ITERATE_Y_SCANLINE_COPY_IMPL_P6

	delete[] src;

	// update
	if (rv > 0) {
		Layer_FuncCall_update(layer, tx1, ty1, sw, sh);
	}

	return 0;
}

#undef F__DEF_RGB_CODE
#undef F__DEF_BETWEEN_2COLORS



// Of[V`ilj
static tjs_int TPFUNCCALL Layer_drawGradatedColorRectImpl_Qua(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int w,
	tjs_int h,
	tjs_real fdir,
	tjs_uint32 * cols,
	tjs_int numCols,
	tjs_int opa)
{
	tjs_int rv = 0;
	const tTVPRect * const draw = layer->drawRect;
	const tjs_int face = layer->face;

	// Ή`惂[h
	if (face == dfMask || face == dfProvince) return -1;

	// `捂
	tjs_int ty1 = (y < draw->top) ? draw->top : y;	// updatë
	tjs_int ty2 = (y + h - 1 > draw->bottom) ? draw->bottom : (y + h - 1);
	tjs_int sh = ty2 - ty1 + 1;	// updatë

	if (sh <= 0) return 0;

	// ӂƉEӂ̏cOf[V
	tjs_uint32 * vsrcleft  = new tjs_uint32[h];
	tjs_uint32 * vsrcright = new tjs_uint32[h];
	{
		tjs_uint32 cols_work[2];

		cols_work[0] = cols[0];
		cols_work[1] = cols[3]; 
		makeMultiGradationPattern(cols_work, 2, vsrcleft, h, opa);
		cols_work[0] = cols[1];
		cols_work[1] = cols[2]; 
		makeMultiGradationPattern(cols_work, 2, vsrcright, h, opa);
	}

	// Of[Vp^[
	tjs_uint32 * src = new tjs_uint32[w];

	try {
		tjs_uint32 cols_work[2];
		// XLCRs[
		for (tjs_int py = ty1; py <= ty2; py++) {
			cols_work[0] = vsrcleft [py - ty1];
			cols_work[1] = vsrcright[py - ty1];
			makeMultiGradationPattern(cols_work, 2, src, w, opa);
			rv += Layer_copyHorizontalLineImpl(layer, x, py, w, src, opa);
		}
	} catch (...) {
		delete[] src;
		delete[] vsrcleft;
		delete[] vsrcright;
		throw;
	}

	delete[] src;
	delete[] vsrcleft;
	delete[] vsrcright;

	// update
	if (rv > 0) {
		tjs_int tx1 = (x < draw->left) ? draw->left : x;	// updatë
		tjs_int tx2 = (x + w - 1 > draw->right) ? draw->right : (x + w - 1);
		tjs_int sw = tx2 - tx1 + 1;	// updatë
		Layer_FuncCall_update(layer, tx1, ty1, sw, sh);
	}

	return rv;
}



// `Of[VhԂ
/*
cols[0]  cols[n] ɐ`ωȂhԂĂB
Of[V^Cv
Eォ牺
EE
ER
̂ꂩB
*/

tjs_int TPFUNCCALL Layer_drawGradatedColorRectImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int w,
	tjs_int h,
	tjs_int type,
	tjs_real dir,
	tjs_uint32 * cols,
	tjs_int numCols,
	tjs_int opa)
{
	const tTVPRect * const draw = layer->drawRect;

	// no action
	if ((w <= 0) ||
		(h <= 0) || 
		(x + w < draw->left) ||
		(y + h < draw->top) ||
		(x > draw->right) ||
		(y > draw->bottom))
		return 0;

	// K
	REG_OPA(opa);

	tjs_int rv = 0;

	switch (type) {

	// Eis Of[V
	case TP_GRAD_TYPE_GRADIENT_L2R:
		rv = Layer_drawGradatedColorRectImpl_L2R(layer, x, y, w, h, cols, numCols, opa);
		break;

	// とis Of[V
	case TP_GRAD_TYPE_GRADIENT_T2B:
		rv = Layer_drawGradatedColorRectImpl_T2B(layer, x, y, w, h, cols, numCols, opa);
		break;

	// w Of[V
	case TP_GRAD_TYPE_GRADIENT_SPEC:
		rv = Layer_drawGradatedColorRectImpl_Specified(layer, x, y, w, h, dir, cols, numCols, opa);
		break;

	// l Of[V
	case TP_GRAD_TYPE_GRADIENT_QUAD:
		rv = Layer_drawGradatedColorRectImpl_Qua(layer, x, y, w, h, dir, cols, numCols, opa);
		break;
	}

	return rv;
}





// Of[V~`
/*
C犮Sɂ͂ݏoĂ珈svB
~b`Fi[̃ASYőȂ琅ŃOf[VB

*/

// ~b`Fi[
#define F__MICHENER_COND_IMPL \
	dy++; \
	E += 4 * dy + 2; \
	if ( E >= 0 ) { \
		dx--; \
		E -= 4 * dx; \
	}




/*
   ^PP_
 ^    QQ_
b   yblen b
b          b
 _        ^
   _QQ^

   ^PP_
 ^QQQQ_  scan line = dest
b   yb    b
b          b
 _        ^
   _QQ^


	scan-length = 2 * len + 1
*/

static void TPFUNCCALL makeTriangleGradationPattern(
	tjs_int y, // Y pos
	tjs_int len, 	// (scan-length - 1) / 2
	tjs_int r, 	// radius
	const tjs_uint32 * src, // gradation pattern base
	tjs_int srcSize, // pattern length
	tjs_uint32 * dest) // destination buffer
{
	for (tjs_int i = 0; i <= len; i++) {
		tjs_int pos = ::sqrt(i*i+y*y);	// 
		tjs_int index = srcSize * pos / (r + 1);	// src̃CfbNX
		dest[len - i] = dest[len + i] = src[index];
	}
}

// ȉ~p
static void TPFUNCCALL makeTriangleGradationPattern(
	tjs_int y, // Y pos
	tjs_int len, 	// (scan-length - 1) / 2
	tjs_int ra, 	// radius
	tjs_int rb, 	// radius
	const tjs_uint32 * src,	// gradation pattern base
	tjs_int srcSize,	// pattern length
	tjs_uint32 * dest)	// destination buffer
{
	for (tjs_int i = 0; i <= len; i++) {
		tjs_int k = ::sqrt(
			(tjs_int64)(i * i) * (tjs_int64)(rb * rb) + 
			(tjs_int64)(y * y) * (tjs_int64)(ra * ra) + 1);
		tjs_int ka = ra * rb;
		tjs_int index = srcSize * k /  ka;	// src̃CfbNX
		if (index >= srcSize) index = srcSize - 1;
		dest[len - i] = dest[len + i] = src[index];
	}
}



tjs_int TPFUNCCALL Layer_drawGradatedColorCircleImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_real r,
	tjs_uint32 * cols,
	tjs_int numCols,
	tjs_int opa)
{
	// `sv
	if ((r <= 0) || 
		(x - r > layer->width) ||
		(y - r > layer->height) ||
		(x + r < 0) ||
		(y + r < 0)) 
		return 0;

	tjs_int rv = 0;
	const tTVPRect * const draw = layer->drawRect;
	const tjs_int face = layer->face;

	// Ή`惂[h
	if (face == dfMask || face == dfProvince) return -1;

	tjs_int dx = r;
	tjs_int dy = 1;
	tjs_int prevdx = dy-1;
	tjs_int E = -2 * r + 3;

	// Of[Vp^[obt@ix[Xj쐬
	const tjs_int bufferLen = 256 * (numCols - 1);
	tjs_uint32 * src = new tjs_uint32[bufferLen];
	CALL_MAKE_MULTI_GRAD_PAT(cols, numCols, src, bufferLen, opa)

	// [NpOf[Vobt@
	tjs_uint32 * const workbuffer = new tjs_uint32[2 * r + 1];

	try {
		// S
		makeTriangleGradationPattern(0, r, r, src, bufferLen, workbuffer);
		rv += Layer_copyHorizontalLineImpl(layer, x - r, y, 2 * r + 1, workbuffer, opa);

		while (dx >= dy) {
			tjs_int len = dx * 2 + 1;
			// [N쐬
			makeTriangleGradationPattern(dy, dx, r, src, bufferLen, workbuffer);
			rv += Layer_copyHorizontalLineImpl(layer, x - dx, y + dy, len, workbuffer, opa);
			rv += Layer_copyHorizontalLineImpl(layer, x - dx, y - dy, len, workbuffer, opa);

			//xh~
			if (prevdx != dx && dx != dy) {
				tjs_int len = dy * 2 + 1;
				// [N쐬
				makeTriangleGradationPattern(dx, dy, r, src, bufferLen, workbuffer);
				rv += Layer_copyHorizontalLineImpl(layer, x - dy, y + dx, len, workbuffer, opa);
				rv += Layer_copyHorizontalLineImpl(layer, x - dy, y - dx, len, workbuffer, opa);
			}
			prevdx = dx;
			F__MICHENER_COND_IMPL
		}
	} catch (...) {
		delete[] workbuffer;
		delete[] src;
		throw;
	}


	delete[] src;
	delete[] workbuffer;

	// update
	if (rv > 0) {
		Layer_FuncCall_update(layer, x-r, y-r, 2*r+1, 2*r+1);
	}

	return rv;
}


#undef F__ITERATE_Y_SCANLINE_COPY_IMPL_P5
#undef F__ITERATE_Y_SCANLINE_COPY_IMPL_P6
#undef F__MICHENER_COND_IMPL





// ȉ~`ihԂj

// ȉ~p
#define F__MICHENER_COND_IMPL \
	if (F < 0) {	\
		dy++;	\
		F += ra2x2 * (2 * dy + 1);	\
		H += ra2x4 * dy;	\
	} else if (H >= 0) {	\
		dx--;	\
		F -= rb2x4 * dx;	\
		H -= rb2x2 * (2 * dx - 1);	\
	} else {	\
		dx--;	\
		dy++;	\
		F += ra2x2 * ( 2 * dy + 1) - rb2x4 * dx;	\
		H += rb2x2 * (-2 * dx + 1) + ra2x4 * dy;	\
	}

tjs_int TPFUNCCALL Layer_drawGradatedColorEllipseImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int ra,
	tjs_int rb,
	tjs_uint32 * cols,
	tjs_int numCols,
	tjs_int opa)
{
	// `sv
	if ((ra <= 0) || 
		(rb <= 0) || 
		(x - ra > layer->width) ||
		(y - rb > layer->height) ||
		(x + ra < 0) ||
		(y + rb < 0)) 
		return 0;

	tjs_int rv = 0;
	const tTVPRect * const draw = layer->drawRect;
	const tjs_int face = layer->face;
	const CTableHolder * const table = TableHolder;

	const tjs_int longr = (ra > rb) ? ra : rb;

	// Ή`惂[h
	if (face == dfMask || face == dfProvince) return -1;

	const tjs_int ra2x2 = ra * ra * 2;
	const tjs_int rb2x2 = rb * rb * 2;
	const tjs_int ra2x4 = ra * ra * 4;
	const tjs_int rb2x4 = rb * rb * 4;

	tjs_int dx = ra;
	tjs_int dy = 0;
	tjs_int F = (-2 * ra + 1) * rb * rb + ra2x2;
	tjs_int H = (-4 * ra + 2) * rb + (ra * ra);

	//S
	// Of[Vp^[obt@ix[Xj쐬
	const tjs_int bufferLen = 256 * (numCols - 1);
	tjs_uint32 * src = new tjs_uint32[bufferLen];
	CALL_MAKE_MULTI_GRAD_PAT(cols, numCols, src, bufferLen, opa)

	// [NpOf[Vobt@
	tjs_uint32 * const workbuffer = new tjs_uint32[2 * longr + 1];

	try {
		// S
		makeTriangleGradationPattern(0, ra, ra, src, bufferLen, workbuffer);
		rv += Layer_copyHorizontalLineImpl(layer, x - ra, y, 2 * ra + 1, workbuffer, opa);

		tjs_int prevdy = dy;
		F__MICHENER_COND_IMPL

		while (dx > 0) {
			// xh~
			if (dy != prevdy) {
				tjs_int len = 2 * dx + 1;
				makeTriangleGradationPattern(dy, dx, ra, rb, src, bufferLen, workbuffer);
				rv += Layer_copyHorizontalLineImpl(layer, x - dx, y + dy, len, workbuffer, opa);
				rv += Layer_copyHorizontalLineImpl(layer, x - dx, y - dy, len, workbuffer, opa);
			}
			prevdy = dy;
			F__MICHENER_COND_IMPL
		}

		// update
		if (rv > 0) {
			Layer_FuncCall_update(layer, x-ra, y-rb, 2*ra+1, 2*rb+1);
		}
	} catch (...) {
		delete[] workbuffer;
		delete[] src;
		throw;
	}

	delete[] workbuffer;
	delete[] src;

	return rv;
}


#undef F__MICHENER_COND_IMPL

