#ifndef _TVP_PLUGIN_GRAPH_FUNC_H_
#define _TVP_PLUGIN_GRAPH_FUNC_H_

#include "KRLayerIntf.h"
#include "PCurveFunc.h"


// C[C[WQƃ[h
#define TP_LAYER_REF_USER     0
#define TP_LAYER_REF_ALPHA    1
#define TP_LAYER_REF_MASK     2
#define TP_LAYER_REF_OPAQUE   3
#define TP_LAYER_REF_PROVINCE 4
#define TP_LAYER_REF_RED     11
#define TP_LAYER_REF_GREEN   12
#define TP_LAYER_REF_BLUE    13


// K
#define REG_OPA(p) \
	if (p <   0) p = 0; \
	if (p > 255) p = 255;

#define SWAP_INT(a,b,t) t=(a);a=(b);b=(t);


#define F__CHECK_HL_IMPL_RESULT_RETURN(_trv, _rv) \
	if (_trv >= 0) { \
		_rv += _trv; \
	} else { \
		return -1; \
	}

#define F__CHECK_HL_IMPL_RESULT_BREAK(_trv, _rv) \
	if (_trv >= 0) { \
		_rv += _trv; \
	} else { \
		_rv = _trv; \
		break; \
	}


tjs_uint32 GetColorMaskFromRef(tjs_int ref, tjs_uint32 userMask);



// vOC֐


// ifBXpb`j
tjs_int TPFUNCCALL Layer_drawLineImpl(
	LayerInfo * layer,
	tjs_int x1,
	tjs_int y1,
	tjs_int x2,
	tjs_int y2,
	tjs_uint32 col,
	tjs_int opa);

// ΐ
tjs_int TPFUNCCALL Layer_drawSlantLineImpl(
	LayerInfo * layer,
	tjs_int x1,
	tjs_int y1,
	tjs_int x2,
	tjs_int y2,
	tjs_uint32 col,
	tjs_int opa);


// 
tjs_int TPFUNCCALL Layer_drawVerticalLineImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int h,
	tjs_uint32 col,
	tjs_int opa);

// 
tjs_int TPFUNCCALL Layer_drawHorizontalLineImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int w,
	tjs_uint32 col,
	tjs_int opa);

// Rs[
tjs_int TPFUNCCALL Layer_copyHorizontalLineImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int w,
	tjs_uint32 * src,
	tjs_int opa);

// ~
tjs_int TPFUNCCALL Layer_drawCircleImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int r,
	tjs_uint32 col,
	tjs_int opa);

// ~hԂ
tjs_int TPFUNCCALL Layer_drawFillCircleImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int r,
	tjs_uint32 col,
	tjs_int opa);

// ȉ~
tjs_int TPFUNCCALL Layer_drawEllipseImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int ra,
	tjs_int rb,
	tjs_uint32 col,
	tjs_int opa);

// ȉ~hԂ
tjs_int TPFUNCCALL Layer_drawFillEllipseImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int ra,
	tjs_int rb,
	tjs_uint32 col,
	tjs_int opa);

// pۂ`
tjs_int TPFUNCCALL Layer_drawRoundRectImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int w,
	tjs_int h,
	tjs_int r,
	tjs_uint32 col,
	tjs_int opa);

// pۂ`hԂ
tjs_int TPFUNCCALL Layer_drawFillRoundRectImpl(
	LayerInfo * layer,
	tjs_int x,
	tjs_int y,
	tjs_int w,
	tjs_int h,
	tjs_int r,
	tjs_uint32 col,
	tjs_int opa);

// Op`hԂ
tjs_int TPFUNCCALL Layer_drawFillTriangleImpl(
	LayerInfo * layer,
	tjs_int x1,
	tjs_int y1,
	tjs_int x2,
	tjs_int y2,
	tjs_int x3,
	tjs_int y3,
	tjs_uint32 col,
	tjs_int opa);

// pgbNȐ
tjs_int TPFUNCCALL Layer_drawParametricCurveImpl(
	LayerInfo * layer,
	ParametricCurveTracer * curve,
	tjs_uint32 col,
	tjs_int opa);

// C[Wr
// Ȃ0
// قȂ0ȊO
tjs_int TPFUNCCALL Layer_compareImageImpl(
	LayerInfo * infoThis,
	LayerInfo * infoRef,
	tjs_int ref,
	tjs_uint32 userMask);



#endif _TVP_PLUGIN_GRAPH_FUNC_H_

