
#include "TVPPlugIn.h"
#include "KRLayerIntf.h"

#include "KRLayerIntfEx.cpp"


//------------------------------------------------------------------------------
// function Layer.update
//------------------------------------------------------------------------------
void Layer_FuncCall_update(iTJSDispatch2 * layer, const tjs_char * memberName) {
	static tTJSVariant result;
	static tjs_uint32 hint = 0;
	TVP_PLUGIN_TJSDISPATCH2_FUNCCALL_CALLIMPL(layer, Layer, update, &hint, &result, 0, NULL, memberName)
	return;
}

void Layer_FuncCall_update(iTJSDispatch2 * layer) {
	Layer_FuncCall_update(layer, TJSEM_ANON_FUNC);
}



//------------------------------------------------------------------------------
// extra property Layer.clipRect
//------------------------------------------------------------------------------
const tjs_int Layer_PropGetEx_clipRect(iTJSDispatch2 * layer, tTVPRect * dest, const tjs_char * memberName) {
	static tjs_uint32 hint_left   = 0;
	static tjs_uint32 hint_top    = 0;
	static tjs_uint32 hint_width  = 0;
	static tjs_uint32 hint_height = 0;

	tTJSVariant workVal;

	TVP_PLUGIN_TJSDISPATCH2_PROPGET_CALLIMPL(layer, Layer, clipLeft, &hint_left, &workVal, memberName)
	dest->left = workVal;

	TVP_PLUGIN_TJSDISPATCH2_PROPGET_CALLIMPL(layer, Layer, clipTop, &hint_top, &workVal, memberName)
	dest->top  = workVal;

	TVP_PLUGIN_TJSDISPATCH2_PROPGET_CALLIMPL(layer, Layer, clipWidth, &hint_width, &workVal, memberName)
	dest->set_width((tjs_int)workVal - 1);

	TVP_PLUGIN_TJSDISPATCH2_PROPGET_CALLIMPL(layer, Layer, clipHeight, &hint_height, &workVal, memberName)
	dest->set_height((tjs_int)workVal - 1);

	return 1;
}

const tjs_int Layer_PropGetEx_clipRect(iTJSDispatch2 * layer, tTVPRect * dest) {
	return Layer_PropGetEx_clipRect(layer, dest, TJSEM_ANON_FUNC);
}


//------------------------------------------------------------------------------
// function Layer.update (useful)
//------------------------------------------------------------------------------
void Layer_FuncCall_update(LayerInfo * info, tjs_int x, tjs_int y, tjs_int w, tjs_int h, const tjs_char * memberName) {
	static tTJSVariant result;
	static tjs_uint32 hint = 0;
	static tTJSVariant val[4] = {(tjs_int64)0, (tjs_int64)0, (tjs_int64)0, (tjs_int64)0};

	val[0] = (tjs_int64)x;
	val[1] = (tjs_int64)y;
	val[2] = (tjs_int64)w;
	val[3] = (tjs_int64)h;

	tTJSVariant *pval[4] = {val, val+1, val+2, val+3};
	iTJSDispatch2 * layer = info->dispatcher;

	TVP_PLUGIN_TJSDISPATCH2_FUNCCALL_CALLIMPL(layer, Layer, update, &hint, &result, 4, pval, memberName)
	return;
}

void Layer_FuncCall_update(LayerInfo * info, tjs_int x, tjs_int y, tjs_int w, tjs_int h) {
	Layer_FuncCall_update(info, x, y, w, h, TJSEM_ANON_FUNC);
}


//------------------------------------------------------------------------------
// function Layer.colorRect
//------------------------------------------------------------------------------
void Layer_FuncCall_colorRect(iTJSDispatch2 * layer, tjs_int numparams, tTJSVariant **params, const tjs_char * memberName) {
	static tTJSVariant result;
	static tjs_uint32 hint = 0;

	TVP_PLUGIN_TJSDISPATCH2_FUNCCALL_CALLIMPL(layer, Layer, colorRect, &hint, &result, numparams, params, memberName)
	return;
}

void Layer_FuncCall_colorRect(iTJSDispatch2 * layer, tjs_int numparams, tTJSVariant **params) {
	Layer_FuncCall_colorRect(layer, numparams, params, TJSEM_ANON_FUNC);
}
