#include "BinaryStreamNI.h"


//--------------------------------------------------------------
/*
Xe[^X͕ύXȂB
*/
void TJSE_NI_CLASS_NAME(BinaryFileStream)::internalInit(void)
{
	istream = NULL;
	currentMode = -1;
	storageName = TJS_W("");
}
//--------------------------------------------------------------

//--------------------------------------------------------------
void TJSE_NI_CLASS_NAME(BinaryFileStream)::internalRelease(void)
{
	close();
}
//--------------------------------------------------------------

//--------------------------------------------------------------
eTPStreamStatus TJSE_NI_CLASS_NAME(BinaryFileStream)::getLastStatus(void) const
{
	return lastStatus;
}
//--------------------------------------------------------------

//--------------------------------------------------------------
bool TJSE_NI_CLASS_NAME(BinaryFileStream)::isOpen(void) const
{
	return (istream != NULL);
}
//--------------------------------------------------------------

//--------------------------------------------------------------
const ttstr & TJSE_NI_CLASS_NAME(BinaryFileStream)::getStorageName(void) const
{
	return storageName;
}
//--------------------------------------------------------------

//--------------------------------------------------------------
tjs_int TJSE_NI_CLASS_NAME(BinaryFileStream)::getMode(void) const
{
	return currentMode;
}
//--------------------------------------------------------------


//--------------------------------------------------------------
/*
I[vԂȂ TP_STREAM_SUCCESS ɂB
N[YԂȂ TP_STREAM_CLOSED ɂB
*/
void TJSE_NI_CLASS_NAME(BinaryFileStream)::resetStatus(void)
{
	lastStatus = (istream == NULL) ? TP_STREAM_CLOSED : TP_STREAM_SUCCESS;
}
//--------------------------------------------------------------


//--------------------------------------------------------------
bool TJSE_NI_CLASS_NAME(BinaryFileStream)::open(const ttstr & storage, tjs_int mode)
{
	// mode:
	// TJS_BS_READ
	// TJS_BS_WRITE
	// TJS_BS_APPEND
	// TJS_BS_UPDATE

	// TJS_BS_ACCESS_MASK 0x0f

	// JĂ
	close();

	try {
		istream = TVPCreateIStream(storage, mode);
		storageName = storage;
		currentMode = mode;
		lastStatus = TP_STREAM_SUCCESS;
	} catch (...) {
		close();
		throw;
	}

	if (!istream) {
		close();
		return false;
	}

	return true;
}
//--------------------------------------------------------------


//--------------------------------------------------------------
bool TJSE_NI_CLASS_NAME(BinaryFileStream)::close(void)
{
	if (isOpen()) {
		istream->Release();
		istream = NULL;
	}

	internalInit();

	return true;
}
//--------------------------------------------------------------


//--------------------------------------------------------------
tTJSVariantOctet * TJSE_NI_CLASS_NAME(BinaryFileStream)::read(tjs_int size)
{
	tTJSVariantOctet * octdata = NULL;

	if (isOpen()) {
		// _
		if (currentMode == TJS_BS_WRITE) {
			lastStatus = TP_STREAM_INVALID_ACCESS;
			return NULL;
		}

		// I[ł
		if (isEOF()) {
			lastStatus = TP_STREAM_SUCCESS;
			return NULL;
		}

		tjs_uint8 * buffer = NULL;
		unsigned long sizeread = 0;
		HRESULT stat = S_FALSE;
		try {
			buffer = new tjs_uint8[size];
			stat = istream->Read(buffer, size, &sizeread);
		} catch (...) {
			if (buffer) delete[] buffer;
			lastStatus = TP_STREAM_FAILED;
			throw;
		}

		if (stat == S_OK) {
			// I[ɒB킯łȂ̂Ɋ҂TCY菬
			// sƌȂiINebgNULLj
			if (sizeread < size && !isEOF()) {
				lastStatus = TP_STREAM_FAILED;
			} else {
				octdata = TJSAllocVariantOctet(buffer, sizeread);
				lastStatus = TP_STREAM_SUCCESS;
			}
		} else {
			lastStatus = TP_STREAM_FAILED;
			// S_OK̂悤ȋC
		}

		if (buffer) delete[] buffer;
	} else {
		lastStatus = TP_STREAM_FAILED;
	}

	return octdata;

}
//--------------------------------------------------------------


//--------------------------------------------------------------
tjs_uint TJSE_NI_CLASS_NAME(BinaryFileStream)::write(const tTJSVariantOctet * octdata, tjs_int size)
{
	if (isOpen() && octdata) {
		// _
		if (currentMode == TJS_BS_READ) {
			lastStatus = TP_STREAM_INVALID_ACCESS;
			return NULL;
		}

		const tjs_uint8 * buffer = octdata->GetData();
		tjs_int write_size = octdata->GetLength();
		if (write_size > size) write_size = size;
		unsigned long sizewritten = 0;
		HRESULT stat = S_FALSE;
		try {
			stat = istream->Write(buffer, write_size, &sizewritten);
		} catch (...) {
			lastStatus = TP_STREAM_FAILED;
			throw;
		}

		if (stat == S_OK) {
			// ҂TCYƎۂɏTCYႤ
			if (sizewritten < write_size) {
				lastStatus = TP_STREAM_FAILED;
			} else {
				lastStatus = TP_STREAM_SUCCESS;
			}
		} else {
			lastStatus = TP_STREAM_FAILED;
			// S_OK̂悤ȋC
		}
		return sizewritten;

	} else {
		lastStatus = TP_STREAM_FAILED;
		return 0;
	}
}
//--------------------------------------------------------------


//--------------------------------------------------------------
tjs_uint32 TJSE_NI_CLASS_NAME(BinaryFileStream)::seek(tjs_int offset, tjs_int whence)
{
	// seek whence
	// TJS_BS_SEEK_SET 0
	// TJS_BS_SEEK_CUR 1
	// TJS_BS_SEEK_END 2

	if (isOpen()) {
		tjs_uint32 newpos = 0;
		_LARGE_INTEGER liOffset;
		_ULARGE_INTEGER liNewpos;
		liOffset.LowPart = offset;
		HRESULT stat = istream->Seek(liOffset, whence, &liNewpos);
		if (stat == S_OK) {
			lastStatus = TP_STREAM_SUCCESS;
		} else {
			lastStatus = TP_STREAM_FAILED;
		}
		return liNewpos.LowPart;
	}
	return 0;
}
//--------------------------------------------------------------


//--------------------------------------------------------------
tjs_uint32 TJSE_NI_CLASS_NAME(BinaryFileStream)::getSize(void)
{
	if (isOpen()) {
		tjs_uint32 orgpos = getPos();
		tjs_uint32 size = seek(0, TJS_BS_SEEK_END);
		seek(orgpos, TJS_BS_SEEK_SET);
		return size;
	}
	return 0;
}
//--------------------------------------------------------------


//--------------------------------------------------------------
tjs_uint32 TJSE_NI_CLASS_NAME(BinaryFileStream)::getPos(void)
{
	if (isOpen()) {
		return seek(0, TJS_BS_SEEK_CUR);
	}
	return 0;
}
//--------------------------------------------------------------

//--------------------------------------------------------------
bool TJSE_NI_CLASS_NAME(BinaryFileStream)::isEOF(void)
{
	if (isOpen()) {
		return (getPos() >= getSize());
	}
	return true;
}
//--------------------------------------------------------------


