#ifndef _TP_BINARY_STREAM_INTF_H_
#define _TP_BINARY_STREAM_INTF_H_
//--------------------------------------------------------------
// 
//--------------------------------------------------------------

#include "TVPPlugIn.h"

enum eTPStreamStatus
{
	TP_STREAM_SUCCESS  =  0,	// 
	TP_STREAM_FAILED   = -1,	// siėpj
	TP_STREAM_INVALID_ACCESS = -2,	// siǍpȂ̂ɏƂƂȂǁj
	TP_STREAM_CLOSED = -65535	// I[vĂȂ
};


// lCeBuNX
TJSE_NATIVE_CLASS_CLASS_DECL(BinaryFileStream)


// lCeBuCX^X
TJSE_NATIVE_INSTANCE_DECL_BEGIN(BinaryFileStream)
protected:
	// has a
	IStream * istream;

	eTPStreamStatus lastStatus;
	ttstr storageName;
	tjs_int currentMode;

protected:
	virtual void internalInit(void);
	virtual void internalRelease(void);

public:

	// C++ RXgN^
	TJSE_NI_CONSTRUCTOR(BinaryFileStream)
	{
		lastStatus = TP_STREAM_CLOSED;
		internalInit();
	}

	// C++fXgN^
	TJSE_NI_DESTRUCTOR(BinaryFileStream)
	{
		internalRelease();
	}

	// TJS RXgN^
	TJSE_TJS_CONSTRUCTOR_DECL
	{
		return S_OK;
	}

	// TJS fXgN^
	void TJS_INTF_METHOD Invalidate()
	{
		internalRelease();
	}

	// ŏIXe[^X擾܂B
	eTPStreamStatus getLastStatus(void) const;

	// I[ṽXg[W擾܂B
	const ttstr & getStorageName(void) const;

	// I[v[h擾܂B
	tjs_int getMode(void) const;

	// I[vԂ擾܂B
	bool isOpen(void) const;

	// ŏIXe[^XNA܂B
	void resetStatus(void);

	// w肳ꂽt@Cw肳ꂽ[hŃI[v܂B
	virtual bool open(const ttstr & storage, tjs_int mode);

	// ܂B
	virtual bool close(void);

	// w肳ꂽTCYǂݍ݂܂B
	virtual tTJSVariantOctet * read(tjs_int size);

	// w肳ꂽTCY݂܂B
	virtual tjs_uint write(const tTJSVariantOctet * octdata, tjs_int size);

	// w肳ꂽʒuɃV[N܂B
	virtual tjs_uint32 seek(tjs_int offset, tjs_int whence);

	// ʒuwq̈ʒu擾܂B
	virtual tjs_uint32 getPos(void);

	// t@CTCY擾܂B
	virtual tjs_uint32 getSize(void);

	// t@CI[ǂ擾܂B
	virtual bool isEOF(void);

TJSE_NATIVE_INSTANCE_DECL_END



//--------------------------------------------------------------
#endif  _TP_BINARY_STREAM_INTF_H_

