//---------------------------------------------------------------------------
// TJSlCeBuCX^X̎
//---------------------------------------------------------------------------

#include "SQLite3NI.h"



//---------------------------------------------------------------------------
// class TJSE_NI_CLASS_NAME(SQLite3)
//---------------------------------------------------------------------------

// C++ RXgN^
TJSE_NI_CLASS_NAME(SQLite3)::TJSE_NI_CONSTRUCTOR(SQLite3)
{
	db = NULL;
	statements.clear();
	setResultStatus(0, TJS_W(""));
	onErrorClose(true);	// ɕ܂
}


// C++fXgN^
TJSE_NI_CLASS_NAME(SQLite3)::TJSE_NI_DESTRUCTOR(SQLite3)
{
	close();
}

// G[ɃN[Y܂H
void TJSE_NI_CLASS_NAME(SQLite3)::onErrorClose(bool flag)
{
	flagOnErrorClose = flag;
}

// G[ɃN[Y܂H
bool TJSE_NI_CLASS_NAME(SQLite3)::onErrorClose(void) const
{
	return flagOnErrorClose;
}

// open DB
bool TJSE_NI_CLASS_NAME(SQLite3)::open(tTJSString & file)
{
	bool rv = false;
	if (db == NULL) {
		db = new sqlite3plus::SqliteConnection(file.c_str());
		rv = true;
	}
	return rv;
}

// close DB
void TJSE_NI_CLASS_NAME(SQLite3)::close(void)
{
	if (isOpen()) {
		// Xe[ggSĕ
		for (std::list<TJSE_NI_CLASS_NAME(SQLite3Statement) *>::iterator it = statements.begin(); it != statements.end(); it++) {
			(*it)->close(false);	//ʒmȂĂł
		}
		statements.clear();

		db->close();
		db = NULL;
	}
}

bool TJSE_NI_CLASS_NAME(SQLite3)::isOpen(void) const
{
	return (db != NULL);
}


// execute query (direct)
void TJSE_NI_CLASS_NAME(SQLite3)::executeQuery(tTJSString & query)
{
	if (isOpen()) {
		sqlite3plus::SqliteStatementPtr statement = db->createStatement(query.c_str());
		statement->execute();
	}
}

// check query
bool TJSE_NI_CLASS_NAME(SQLite3)::isCompleteSQL(tTJSString & query)
{
	bool rv = false;
	if (isOpen()) {
		rv = db->isCompleteSql(query.c_str());
	}
	return rv;
}

// column names
tjs_int TJSE_NI_CLASS_NAME(SQLite3)::columnNames(tTJSString & table, iTJSDispatch2 * array)
{
	tjs_int cols = 0;
	if (isOpen()) {
		std::vector<sqlite3plus::SqliteString> vnames = db->columnNames(table.c_str());
		cols = vnames.size();
		for (std::vector<sqlite3plus::SqliteString>::iterator it = vnames.begin(); it != vnames.end(); it++) {
			tTJSVariant name(it->c_str());
			Array_FuncCall_add(array, &name);
		}
	}
	return cols;
}

// get version (static)
void TJSE_NI_CLASS_NAME(SQLite3)::version(tTJSString & rv)
{
	rv = (sqlite3plus::SqliteConnection::version()).c_str();
}

// get connection ref.
sqlite3plus::SqliteConnection * TJSE_NI_CLASS_NAME(SQLite3)::getConnection(void) const
{
	return db;
}


tjs_int TJSE_NI_CLASS_NAME(SQLite3)::getResultCode(void) const
{
	return resultCode;
}

const ttstr & TJSE_NI_CLASS_NAME(SQLite3)::getResultMessage(void) const
{
	return resultMessage;
}

void TJSE_NI_CLASS_NAME(SQLite3)::setResultStatus(tjs_int code, const ttstr & message)
{
	resultCode = code;
	resultMessage = message;
}

void TJSE_NI_CLASS_NAME(SQLite3)::setResultStatus(tjs_int code)
{
	resultCode = code;
}

// Xe[gg쐬܂B
void TJSE_NI_CLASS_NAME(SQLite3)::createStatement(TJSE_NI_CLASS_NAME(SQLite3Statement) * st, const ttstr & query)
{
	if (st && isOpen()) {
		st->set(this, query);
		statements.push_back(st);	// Xgɒǉ
	} else {
		// TODO
	}
}

// Xe[gg폜܂iʒmpjB
void TJSE_NI_CLASS_NAME(SQLite3)::deleteStatement(TJSE_NI_CLASS_NAME(SQLite3Statement) * st)
{
	if (st && isOpen()) {
		statements.remove(st);	// Xg폜
	}
}



//---------------------------------------------------------------------------
// class TJSE_NI_CLASS_NAME(SQLite3Statement)
//---------------------------------------------------------------------------

// C++ RXgN^
TJSE_NI_CLASS_NAME(SQLite3Statement)::TJSE_NI_CONSTRUCTOR(SQLite3Statement)
{
	conn = NULL;
	cursors.clear();
	statement = NULL;
	queryString = TJS_W("");
}

// C++fXgN^
TJSE_NI_CLASS_NAME(SQLite3Statement)::TJSE_NI_DESTRUCTOR(SQLite3Statement)
{
	close();
}

void TJSE_NI_CLASS_NAME(SQLite3Statement)::set(TJSE_NI_CLASS_NAME(SQLite3) * c, const tTJSString & query)
{
	if (isOpen()) {
		close();
	}

	sqlite3plus::SqliteStatement * st = c->getConnection()->createStatement(query.c_str());
	statement = st;
	conn = c;
	queryString = query;
}

void TJSE_NI_CLASS_NAME(SQLite3Statement)::close(bool unregister)
{
	if (isOpen()) {
		// J[\Sĕ
		for (std::list<TJSE_NI_CLASS_NAME(SQLite3Cursor) *>::iterator it = cursors.begin(); it != cursors.end(); it++) {
			(*it)->close(false);	//ʒmȂĂł
		}
		cursors.clear();

		if (conn) {
			if (unregister) conn->deleteStatement(this);	// ʒm
			conn = NULL;
		}
		delete statement;
		statement = NULL;
	}
}

bool TJSE_NI_CLASS_NAME(SQLite3Statement)::isOpen(void) const
{
	return (this->statement != NULL);
}


void TJSE_NI_CLASS_NAME(SQLite3Statement)::execute(void)
{
	statement->execute();
}

void TJSE_NI_CLASS_NAME(SQLite3Statement)::reset(void)
{
	statement->reset();
}

sqlite3plus::SqliteStatement * TJSE_NI_CLASS_NAME(SQLite3Statement)::getStatement(void)
{
	return statement;
}

const ttstr & TJSE_NI_CLASS_NAME(SQLite3Statement)::getQueryString(void) const
{
	return queryString;
}


TJSE_NI_CLASS_NAME(SQLite3) * TJSE_NI_CLASS_NAME(SQLite3Statement)::getNIConnection(void)
{
	return conn;
}


// J[\擾܂B
void TJSE_NI_CLASS_NAME(SQLite3Statement)::createCursor(TJSE_NI_CLASS_NAME(SQLite3Cursor) * cur)
{
	if (cur) {
		cur->set(this);
		cursors.push_back(cur);	// Xgɒǉ
	} else {
		// TODO
	}
}

// J[\폜܂iʒmpjB
void TJSE_NI_CLASS_NAME(SQLite3Statement)::deleteCursor(TJSE_NI_CLASS_NAME(SQLite3Cursor) * cur)
{
	if (cur) {
		cursors.remove(cur);	// Xg폜
	}
}


//---------------------------------------------------------------------------
// class TJSE_NI_CLASS_NAME(SQLite3Cursor)
//---------------------------------------------------------------------------

// C++ RXgN^
TJSE_NI_CLASS_NAME(SQLite3Cursor)::TJSE_NI_CONSTRUCTOR(SQLite3Cursor)
{
	statement = NULL;
	cursor = NULL;
}

// C++fXgN^
TJSE_NI_CLASS_NAME(SQLite3Cursor)::TJSE_NI_DESTRUCTOR(SQLite3Cursor)
{
	close();
}

void TJSE_NI_CLASS_NAME(SQLite3Cursor)::set(TJSE_NI_CLASS_NAME(SQLite3Statement) * s)
{
	if (isOpen()) {
		close();
	}

	statement = s;
	sqlite3plus::SqliteStatement * st = s->getStatement();
	sqlite3plus::SqliteCursor * cr = st->executeQuery();
	this->cursor = cr;
}

void TJSE_NI_CLASS_NAME(SQLite3Cursor)::close(bool unregister)
{
	if (isOpen()) {
		if (statement) {
			if (unregister) statement->deleteCursor(this);	// ʒm
			statement = NULL;
		}
		delete cursor;
		cursor = NULL;
	}
}

bool TJSE_NI_CLASS_NAME(SQLite3Cursor)::isOpen(void) const
{
	return (this->cursor != NULL);
}

bool TJSE_NI_CLASS_NAME(SQLite3Cursor)::next(void)
{
	return cursor->next();
}

bool TJSE_NI_CLASS_NAME(SQLite3Cursor)::isEOR(void)
{
	return cursor->eor();
}

void TJSE_NI_CLASS_NAME(SQLite3Cursor)::reset(void)
{
	return cursor->reset();
}

tjs_int TJSE_NI_CLASS_NAME(SQLite3Cursor)::columnType(tjs_int index)
{
	sqlite3plus::SqliteCursor * c = cursor;
	if (c->isInt(index))  return TP_SQ3_DATATYPE_INTEGER;
	if (c->isStr(index))  return TP_SQ3_DATATYPE_STRING;
	if (c->isReal(index)) return TP_SQ3_DATATYPE_REAL;
	if (c->isNull(index)) return TP_SQ3_DATATYPE_NULL;
	if (c->isBlob(index)) return TP_SQ3_DATATYPE_BLOB;
	return TP_SQ3_DATATYPE_VOID;
}


sqlite3plus::SqliteCursor * TJSE_NI_CLASS_NAME(SQLite3Cursor)::getCursor(void)
{
	return cursor;
}

tjs_int TJSE_NI_CLASS_NAME(SQLite3Cursor)::columnCount()
{
	return cursor->colNum();
}

void TJSE_NI_CLASS_NAME(SQLite3Cursor)::columnName(tjs_int index, tTJSString & rv)
{
	rv = cursor->colName(index).c_str();
}

TJSE_NI_CLASS_NAME(SQLite3Statement) * TJSE_NI_CLASS_NAME(SQLite3Cursor)::getNIStatement(void)
{
	return statement;
}

