#ifndef _TVP_PLUGIN_SQLITE3_INTF_H_
#define _TVP_PLUGIN_SQLITE3_INTF_H_

//#include "SqlitePlus.h"
#include "SqlitePlus.h"
#include "TVPPlugIn.h"
#include <list>

// f[^^
// TODO: enum
#define TP_SQ3_DATATYPE_NULL    1
#define TP_SQ3_DATATYPE_AUTO    2
#define TP_SQ3_DATATYPE_INTEGER 3
#define TP_SQ3_DATATYPE_REAL    4
#define TP_SQ3_DATATYPE_STRING  5
#define TP_SQ3_DATATYPE_BLOB    6
#define TP_SQ3_DATATYPE_VOID    999999


// lCeBuNX
TJSE_NATIVE_CLASS_CLASS_DECL(SQLite3)
TJSE_NATIVE_CLASS_CLASS_DECL(SQLite3Statement)
TJSE_NATIVE_CLASS_CLASS_DECL(SQLite3Cursor)

// lCeBuCX^X
class TJSE_NI_CLASS_NAME(SQLite3);
class TJSE_NI_CLASS_NAME(SQLite3Statement);
class TJSE_NI_CLASS_NAME(SQLite3Cursor);


//---------------------------------------------------------------------------
// lCeBuCX^X SQLite3
//---------------------------------------------------------------------------
TJSE_NATIVE_INSTANCE_DECL_BEGIN(SQLite3)
protected:
	sqlite3plus::SqliteConnection * db;	// has a
	std::list<TJSE_NI_CLASS_NAME(SQLite3Statement) *> statements; //Xe[ggXg
	tjs_int resultCode;	// ŏIXe[^X
	ttstr resultMessage;
	bool flagOnErrorClose;

public:

	// C++ RXgN^
	TJSE_NI_CONSTRUCTOR(SQLite3);

	// C++fXgN^
	TJSE_NI_DESTRUCTOR(SQLite3);

	// TJS RXgN^
	TJSE_TJS_CONSTRUCTOR_DECL
	{
		return S_OK;
	}

	// TJS fXgN^
	void TJS_INTF_METHOD Invalidate()
	{
		close();
	}

	// JĂ܂H
	bool isOpen(void) const;

	// G[ɃN[Y܂H
	void onErrorClose(bool flag);
	bool onErrorClose(void) const;

	// J܂B
	virtual bool open(tTJSString & file);

	// ܂Bq܂B
	virtual void close(void);

	// s܂B
	virtual void executeQuery(tTJSString & query);

	// Ă邩ׂ܂B
	virtual bool isCompleteSQL(tTJSString & query);

	// e[ũJ擾܂B
	virtual tjs_int columnNames(tTJSString & table, iTJSDispatch2 * array);

	// o[W擾܂B
	static void version(tTJSString & rv);

	// SQLitePlus̃RlNV擾܂B
	sqlite3plus::SqliteConnection * getConnection() const;

	// ŏIXe[^X擾܂B
	tjs_int getResultCode(void) const;
	// ŏIXe[^XbZ[W擾܂B
	const ttstr & getResultMessage(void) const;

	// ŏIXe[^XƃbZ[WZbg܂B
	void setResultStatus(tjs_int code, const ttstr & message);
	// ŏIXe[^XZbg܂B
	void setResultStatus(tjs_int code);

	// Xe[gg쐬܂B
	void createStatement(TJSE_NI_CLASS_NAME(SQLite3Statement) * st, const ttstr & query);

	// Xe[gg폜܂iʒmpjB
	void deleteStatement(TJSE_NI_CLASS_NAME(SQLite3Statement) * st);

TJSE_NATIVE_INSTANCE_DECL_END





//---------------------------------------------------------------------------
// lCeBuCX^X SQLite3Statement
//---------------------------------------------------------------------------
TJSE_NATIVE_INSTANCE_DECL_BEGIN(SQLite3Statement)
protected:
	TJSE_NI_CLASS_NAME(SQLite3) * conn;	// e
	sqlite3plus::SqliteStatement * statement;	// has a
	std::list<TJSE_NI_CLASS_NAME(SQLite3Cursor) *> cursors; //J[\Xg
	ttstr queryString;

public:
	// C++ RXgN^
	TJSE_NI_CONSTRUCTOR(SQLite3Statement);

	// C++fXgN^
	TJSE_NI_DESTRUCTOR(SQLite3Statement);

	// TJS RXgN^
	TJSE_TJS_CONSTRUCTOR_DECL
	{
		return S_OK;
	}

	// TJS fXgN^
	void TJS_INTF_METHOD Invalidate()
	{
		close();
	}

	// ܂Bq܂B
	void close(bool unregister = true);

	// LłH
	bool isOpen(void) const;

	// eƃNGZbg܂B
	virtual void set(TJSE_NI_CLASS_NAME(SQLite3) * c, const tTJSString & query);

	// s܂B
	virtual void execute(void);

	// Zbg܂B
	virtual void reset(void);

	// SQLitePlus̃Xe[gg擾܂B
	sqlite3plus::SqliteStatement * getStatement(void);

	// NG擾܂B
	const ttstr & getQueryString(void) const;

	// e擾܂B
	TJSE_NI_CLASS_NAME(SQLite3) * getNIConnection(void);

	// J[\쐬܂B
	void createCursor(TJSE_NI_CLASS_NAME(SQLite3Cursor) * cur);

	// J[\폜܂iʒmpjB
	void deleteCursor(TJSE_NI_CLASS_NAME(SQLite3Cursor) * cur);

TJSE_NATIVE_INSTANCE_DECL_END




//---------------------------------------------------------------------------
// lCeBuCX^X
//---------------------------------------------------------------------------
TJSE_NATIVE_INSTANCE_DECL_BEGIN(SQLite3Cursor)
protected:
	sqlite3plus::SqliteCursor * cursor;	// has a
	TJSE_NI_CLASS_NAME(SQLite3Statement) * statement;	// e

public:
	// C++ RXgN^
	TJSE_NI_CONSTRUCTOR(SQLite3Cursor);

	// C++fXgN^
	TJSE_NI_DESTRUCTOR(SQLite3Cursor);

	// TJS RXgN^
	TJSE_TJS_CONSTRUCTOR_DECL
	{
		return S_OK;
	}

	// TJS fXgN^
	void TJS_INTF_METHOD Invalidate()
	{
		close();
	}

	// ܂B
	void close(bool unregister = true);

	// LłH
	bool isOpen(void) const;

	// eZbg܂B
	virtual void set(TJSE_NI_CLASS_NAME(SQLite3Statement) * s);

	// ̍s擾܂B
	virtual bool next(void);

	// ŏIsłH
	virtual bool isEOR(void);

	// Zbg܂B
	virtual void reset(void);

	// SQLitePlus̃J[\擾܂B
	sqlite3plus::SqliteCursor * getCursor(void);

	// ̐擾܂B
	virtual tjs_int columnCount(void);

	// ̌^擾܂B
	virtual tjs_int columnType(tjs_int index);

	// ̖O擾܂B
	virtual void columnName(tjs_int index, tTJSString & rv);

	// e擾܂B
	TJSE_NI_CLASS_NAME(SQLite3Statement) * getNIStatement(void);

TJSE_NATIVE_INSTANCE_DECL_END


#endif  _TVP_PLUGIN_SQLITE3_INTF_H_
