/**************************************************************
*
*  Jul. 8, 2004
*
*  The author disclaims copyright to this source code.
*  In place of a legal notice, here is a blessing:
*
*    May you do good and not evil.
*    May you find forgiveness for yourself and forgive others.
*    May you share freely, never taking more than you give.
*
**************************************************************/
#ifndef SqliteConnection_H
#define SqliteConnection_H


#include <vector>
#include "sqlite3.h"
#include "SqliteException.h"
#include "SqliteString.h"
#include "SqliteSmartPtr.h"
#include "SqliteStatement.h"

namespace sqlite3plus {

/// SQLitef[^x[XƂ̐ڑbvNX
class SqliteConnection
{
protected:
	///x[XƂȂSQLiteDBnh
	sqlite3*			m_db;

public:
	///f[^x[Xt@CJɍ\z
	SqliteConnection(void);

	/// f[^x[Xt@Cw肵č\z
	/**
	 * @param dbName f[^x[XƂĊJt@C̖O
	 * @throw ConnectionException I[vłȂ
	 */
	SqliteConnection(const _TCHAR* dbName);

	virtual ~SqliteConnection(void);

	/// DBnh擾
	/**
	 * @return SQLiteDBnh
	 */
	sqlite3* db() const;

	///w肵f[^x[Xt@CJ
	/**
	 * @param dbName f[^x[XƂĊJt@C̖O
	 * @throw ConnectionException I[vłȂ
	 */
	void open(const _TCHAR* dbName);

	/// JĂf[^x[X
	void close();

	/// }`Xbh쎞Aʂ̃XbhsĂXe[ggIB
	/**
	 * @note Xe[ggsɊ荞܂ꂽXbhɂ́AG[R[hSQLITE_INTERRUPT
	 * QueryException
	 */
	void interrupt();

	/// Xe[gg\z
	/**
	 * @param sql sׂSQL
	 * @return \zꂽXe[ggIuWFNgւ̃|C^
	 */
	SqliteStatement * createStatement(const _TCHAR* sql);

	/// SQLitẽo[W擾
	/**
	 * @return SQLitẽo[W
	 */
	static SqliteString version();

	/// Ōɑ}j[NȍsID擾
	/**
	 * @return Ōɑ}j[NȍsID
	 */
	__int64 lastInsertRowID();

	/// ŌINSERT, DELETE, UPDATE̎sŕύXꂽs̐擾
	/**
	 * @return ύXꂽs
	 * @note WHERE߂̂Ȃ DELETÉASQLiteDROP TABLECREATE TABLE
	 * s邱ƂɂĎĂB̏ꍇAlastChangedRowNum()
	 * K0ԂB
	 */
	int lastChangedRowNum();

	/// f[^x[XJĂύXꂽs擾
	/**
	 * @return f[^x[XJĂύXꂽs
	 */
	int lastChangedRowNumTotal();

	///w肵񂪁ASQLƂĐĂ邩ǂ`FbN
	/**
	 * @return SQLƂĐĂtrueAsSȂfalse
	 */
	bool isCompleteSql(const _TCHAR* sql);

	/// we[u̗񖼔z擾
	/**
	 * @param tableName 񖼂擾e[u̖O
	 * @return 񖼂̔z
	 */
	std::vector<SqliteString> columnNames(const _TCHAR* tableName);
};


}; //end of namespace sqlite3plus

#endif SqliteConnection_H

