/**************************************************************
*
*  Jul. 8, 2004
*
*  The author disclaims copyright to this source code.
*  In place of a legal notice, here is a blessing:
*
*    May you do good and not evil.
*    May you find forgiveness for yourself and forgive others.
*    May you share freely, never taking more than you give.
*
**************************************************************/
#ifndef SqliteFunction_H
#define SqliteFunction_H

#include "sqlite3.h"
#include "SqliteString.h"
#include "SqliteException.h"

namespace sqlite3plus {

/// [U`֐/AOQ[g̃x[XƂȂNX
class SqliteFunctionBase
{
public:
	/// ֐o^f[^x[Xnh
	sqlite3*			m_db;
	/// ֐̌ĂяoReLXgێiSQLite֐Ăяoۂɓnj
	sqlite3_context*	m_ctx;
	/// ֐
	SqliteString		m_name;
	/// ֐̎̐
	int					m_nArgs;
	/// ֐o^ɓn[Uf[^
	void*				m_userData;

protected:
	/// ی삳ꂽRXgN^B̃NX𒼐ڃCX^X邱Ƃ͖B
	/**
	 * @db SQLitef[^x[Xnh
	 */
	SqliteFunctionBase(sqlite3* db);

public:
	virtual ~SqliteFunctionBase();

	/// ֐ɓnꂽ̃^CvANULLł邩`FbN
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return ̃^CvNULLłtrueAłȂfalse
	 */
	bool isNull(sqlite3_value* param);

	/// ֐ɓnꂽ̃^CvAł邩`FbN
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return ̃^CvłtrueAłȂfalse
	 */
	bool isStr(sqlite3_value* param);

	/// ֐ɓnꂽ̃^CvAł邩`FbN
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return ̃^CvłtrueAłȂfalse
	 */
	bool isInt(sqlite3_value* param);

	/// ֐ɓnꂽ̃^CvAł邩`FbN
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return ̃^CvłtrueAłȂfalse
	 */
	bool isReal(sqlite3_value* param);

	/// ֐ɓnꂽ̃^CvABLOBł邩`FbN
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return ̃^CvBLOBłtrueAłȂfalse
	 */
	bool isBlob(sqlite3_value* param);

	/// ֐ɓnꂽ̒lAƂĎ擾
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return 擾̒l
	 */
	SqliteString valueAsStr(sqlite3_value* param);

	/// ֐ɓnꂽ̒lAƂĎ擾
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return 擾̒l
	 */
	int valueAsInt(sqlite3_value* param);

	/// ֐ɓnꂽ̒lA64bitƂĎ擾
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return 擾̒l
	 */
	__int64 valueAsInt64(sqlite3_value* param);

	/// ֐ɓnꂽ̒lAƂĎ擾
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return 擾̒l
	 */
	double valueAsReal(sqlite3_value* param);

	/// ֐ɓnꂽ̒lABLOBƂĎ擾
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return 擾̒l
	 */
	const void* valueAsBlob(sqlite3_value* param);

	/// ֐ɓnꂽ̃oCg擾
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return oCg
	 * @note ̏ꍇAUTF8ƂẴoCgԂ
	 */
	int valueBytes(sqlite3_value* param);

	/// ֐ɓnꂽ̃oCg擾
	/**
	 * @param param SqliteFunction::onCall(), SqliteAggregate::onStep() ɓnꂽ
	 * @return 擾̒l
	 * @note ̏ꍇAUTF16ƂẴoCgԂ
	 */
	int valueBytes16(sqlite3_value* param);

	/// ֐̖߂liljZbg
	/**
	 * @param val ߂l
	 */
	void setReturn(int val);

	/// ֐̖߂li64bitljZbg
	/**
	 * @param val ߂l
	 */
	void setReturn(__int64 val);

	/// ֐̖߂liljZbg
	/**
	 * @param val ߂l
	 */
	void setReturn(double val);

	/// ֐̖߂lijZbg
	/**
	 * @param val ߂l
	 */
	void setReturn(const _TCHAR* val);

	/// ֐̖߂liBLOBjZbg
	/**
	 * @param val ߂l
	 * @param nBytes ߂l̃oCg
	 * @param makeCopy val̃Rs[쐬Ė߂lƂꍇtrueA
	 * val|C^̂܂ܖ߂ꍇfalse
	 * @note makeCopyfalsȅꍇA֐ďoI
	 * SQLŖ߂l𗘗pI܂ŁAval̎wĂ͂ȂȂB
	 */
	void setReturn(const void* val, int nBytes, bool makeCopy=true);
};

/// [U`֐쐬邽߂̃x[XNX
class SqliteFunction
	: protected SqliteFunctionBase
{
public:
	/// RXgN^
	/**
	 * @param db ֐o^SQLitef[^x[Xnh
	 */
	SqliteFunction(sqlite3* db)
		: SqliteFunctionBase(db)
	{}

	virtual ~SqliteFunction()
	{
		destroy();
	}

	/// o^[U`֐Ăяo鎞ɌĂ΂
	/**
	 * @param argc argv̗vf
	 * @param argv [U`֐ɓnꂽ̔z
	 * @param userData create()ɓnuserDataƓ
	 * @note ߂lԂ[U`֐̏ꍇÃ\bh߂O
	 * SqliteFunctionBase::setReturn()pĖ߂lZbgKvB
	 */
	virtual void onCall(int argc, sqlite3_value** argv, void* userData) = 0;

	/// [U`֐SQLiteɓo^
	/**
	 * @param funcName [U`֐
	 * @param nArgs [U`֐̎̐
	 * @parma userData [Uf[^
	 */
	void create(const _TCHAR* funcName, int nArgs, void* userData);

	/// [U`֐̓o^
	void destroy();

protected:
	/// gp
	static void delegateCall(
		sqlite3_context* ctx,
		int nArgs,
		sqlite3_value** params);
};


/// [U`AOQ[g쐬邽߂̃x[XNX
class SqliteAggregate
	: protected SqliteFunctionBase
{
public:
	/// RXgN^
	/**
	 * @param db AOQ[go^SQLitef[^x[Xnh
	 */
	SqliteAggregate(sqlite3* db)
		: SqliteFunctionBase(db)
	{}

	virtual ~SqliteAggregate()
	{
		destroy();
	}

	/// AOQ[ĝPXebvƂɌĂяo
	/**
	 * @param argc argv̐
	 * @param argv AOQ[gɗ^ꂽ̐
	 * @param userData [Uf[^icreate()ɓnꂽ̂Ɠj
	 */
	virtual void onStep(int argc, sqlite3_value** argv, void* userData) = 0;

	/// AOQ[g̍Ō̃XebvIɌĂ΂
	/**
	 * @param userData icreate()ɓnꂽ̂Ɠj
	 */
	virtual void onFinal(void* userData) = 0;

	/// AOQ[gSQLiteɓo^
	/**
	 * @param funcName AOQ[g̖O
	 * @param nArgs AOQ[g̎̐
	 * @param userData onStep(), onFinal()ɓn[Uf[^
	 */
	void create(const _TCHAR* funcName, int nArgs, void* userData);

	/// AOQ[g̓o^
	void destroy();

protected:
	/// gp
	static void delegateStep(
		sqlite3_context* ctx,
		int nArgs,
		sqlite3_value** params);

	/// gp
	static void delegateFinal(
		sqlite3_context* ctx);
};


/// [U`r֐쐬邽߂̃x[XNX
class SqliteCollation
{
protected:
	/// [U`r֐o^̃f[^x[Xnh
	sqlite3*		m_db;
	/// r֐̖O
	SqliteString	m_name;
	/// [Uf[^icreate()œnj
	void*			m_userData;

public:
	/// RXgN^
	/**
	 * @param r֐o^̃f[^x[Xnh
	 */
	SqliteCollation(sqlite3* db)
		: m_db(db)
	{}

	virtual ~SqliteCollation()
	{
		destroy();
	}

	/// rsxɌĂ΂BhNXŃI[o[ChB
	/**
	 * @param var1 
	 * @param var2 
	 * @param userData create()ɓnuserDataƓ
	 * @return var1var2菬ꍇ͕̒lA
	 * var1var2傫ꍇ͐̒lA
	 * var1var2ꍇ0ԂB
	 */
	virtual int onCompare(
		const SqliteString& var1,
		const SqliteString& var2,
		void* userData) = 0;

	/// r֐SQLiteɓo^
	/**
	 * @param funcName ֐
	 * @param userData onCompare()ɓn[Uf[^
	 */
	void create(const _TCHAR* funcName, void* userData);

	/// r֐̓o^
	void destroy();

protected:
	/// gp
	static int delegateCompare(
		void* userData,
		int nLen1, const void* str1,
		int nLen2, const void* str2);
};


}; // end of namespace sqlite3plus

#endif SqliteFunction_H

