/**************************************************************
*
*  Jul. 8, 2004
*
*  The author disclaims copyright to this source code.
*  In place of a legal notice, here is a blessing:
*
*    May you do good and not evil.
*    May you find forgiveness for yourself and forgive others.
*    May you share freely, never taking more than you give.
*
**************************************************************/
#ifndef SqliteSmartPtr_H
#define SqliteSmartPtr_H

#include <windows.h>
#include <cassert>

namespace sqlite3plus {

/// t@XJEg̃X}[g|C^
/**
 * t@XJEg̃X}[g|C^B<br>
 * t@XJEgSqliteSmartPtr̃Rs[ɂđA
 * łɂČB<br>
 * t@XJEg[ɂȂ_iSẴIuWFNgł_j
 * CX^XIdeleteB<br>
 * @note InterlockedIncrement/Decrement()gpĂ邪A
 * XbhZ[tł͂ȂB}`XbhŎgpꍇ́A
 * boost::shared_ptrȂǂŒu邩AĂяoœs˂΂ȂȂB
 */
template<typename T>
class SqliteSmartPtr
{
protected:
	/// CX^Xւ̃|C^ێ
	T*					m_ptr;
	/// t@XJEg
	LONG*				m_refCount;

public:
	/// X}[g|C^\z
	/**
	 * @param ptr ێ|C^
	 */
	SqliteSmartPtr(T* ptr=0)
		: m_ptr(ptr)
		, m_refCount(0)
	{
		if(ptr)
		{
			m_refCount = new LONG;
			*m_refCount = 1;
		}
	}

	/// X}[g|C^\z
	/**
	 * @param another ʂSqliteSmartPtrCX^Xւ̎Q
	 */
	SqliteSmartPtr(SqliteSmartPtr<T>& another)
		: m_ptr(0)
		, m_refCount(0)
	{
		*this = another;
	}

	~SqliteSmartPtr()
	{
		release();
	}

	/// X}[g|C^̕ێQƂ
	/**
	 * @return ܂ŕێĂCX^Xւ̎QƁiNULL̏ꍇj
	 */
	T* release()
	{
		T* ret = m_ptr;
		if(m_refCount)
		{
			LONG refCount = ::InterlockedDecrement(m_refCount);

			if(refCount == 0)
			{
				if(m_ptr)
				{
					delete m_ptr;
				}
				delete m_refCount;
			}

			m_ptr = NULL;
			m_refCount = NULL;
		}

		return ret;
	}

	/// Zq
	SqliteSmartPtr<T>& operator=(SqliteSmartPtr<T>& another)
	{
		if(m_refCount == another.m_refCount)
		{
			//łɓ|C^wĂB
			//t@XJEg͕̑KvȂB
			assert(m_ptr == another.m_ptr);
		}
		else
		{
			//قȂ|C^wĂ

			//܂Ât@X
			release();

			//Vt@Xɏ
			if(another.m_refCount)
			{
				::InterlockedIncrement(another.m_refCount);
				m_ptr = another.m_ptr;
				m_refCount = another.m_refCount;
			}
		}

		return *this;
	}

	/// ݂̃t@XJEgԂ
	/**
	 * @return ݂̃t@XJEg
	 */
	LONG refCount() const
	{
		if(m_refCount) return *m_refCount;

		return 0;
	}

	/// dereference
	T& operator*() const
	{
		return *m_ptr;
	}

	/// arrow
	T* operator->() const
	{
		return m_ptr;
	}

	/// X}[g|C^̕ێQƂԂ
	T* get() const
	{
		return m_ptr;
	}

	/// X}[g|C^ALȎQƂێĂ΁AtrueԂ
	operator bool() const
	{
		return m_ptr != NULL;
	}

	/// X}[g|C^ALȎQƂێĂȂ΁AtrueԂ
	bool operator!() const
	{
		return (m_ptr==NULL);
	}

	/// ێCX^Xւ̎QƂ΁AtrueԂ
	/**
	 * @note *m_ptr == *(another.m_ptr) ł͂ȂƂɒ
	 */
	bool operator==(const SqliteSmartPtr<T>& another) const
	{
		return (m_ptr == another.m_ptr);
	}
};


}; // end of namespace sqlite3plus

#endif SqliteSmartPtr_H
