/**************************************************************
*
*  Jul. 8, 2004
*
*  The author disclaims copyright to this source code.
*  In place of a legal notice, here is a blessing:
*
*    May you do good and not evil.
*    May you find forgiveness for yourself and forgive others.
*    May you share freely, never taking more than you give.
*
**************************************************************/
#ifndef SqliteStatement_H
#define SqliteStatement_H


#include "sqlite3.h"
#include "SqliteString.h"
#include "SqliteSmartPtr.h"
#include "SqliteException.h"

namespace sqlite3plus {

/// J[\
class SqliteCursor
{
	friend class SqliteStatement;

protected:
	/// UgZbg̑SĂ̍s擾IƁAtrueɃZbg
	bool					m_eor;
	/// ݂܂łɎ擾s̐
	int						m_rowNum;
	/// 
	int						m_colNum;
	/// f[^x[Xnh
	sqlite3*				m_db;
	/// Xe[ggnh
	sqlite3_stmt*			m_stmt;

public:
	/// f[^x[Xnh擾
	sqlite3* db();

	/// Xe[ggnh擾
	sqlite3_stmt* stmt();

protected:
	/// RXgN^B[U͒ڃJ[\NX\zĂ͂ȂȂB
	SqliteCursor(sqlite3_stmt* stmt, sqlite3* db);

public:
	///fXgN^
	virtual ~SqliteCursor();

	/// UgZbg̑SĂ̍s擾IĂ邩ǂ𔻒
	/**
	 * @return ȏ㌋ʍsȂtrueA܂݂false
	 */
	bool eor();

	/// ݂܂łɎ擾sԂ
	/**
	 * @return ݂܂łɎ擾s
	 */
	int rowNum();

	/// UgZbg̗񐔂Ԃ
	/**
	 * @return 
	 */
	int colNum();

	/// ̍s擾
	/**
	 * @return Ɏ̌ʍstrueAꂪŌ̍sȂfalse
	 * @throw QueryException ʂ̎擾Ɏsꍇ
	 */
	bool next();

	/// J[\ʒuďAUgZbg̐擪ɖ߂
	/**
	 * @throw QueryException J[\̍ďɎsꍇ
	 * @note SqliteStatement::reset()Ɠ@\BǂsĂʂłB
	 */
	void reset();

	/// ݃|CgĂs̎w̒lNULLǂ肷
	/**
	 * @param index `FbN̔ԍi0n܂j
	 * @return NULLȂtrueAłȂfalse
	 * @throw OutOfBoundsException index͈͂EĂꍇ
	 */
	bool isNull(int index);

	/// ݃|CgĂs̎w̃^Cv񂩂ǂ肷
	/**
	 * @param index `FbN̔ԍi0n܂j
	 * @return ȂtrueAłȂfalse
	 * @throw OutOfBoundsException index͈͂EĂꍇ
	 */
	bool isStr(int index);

	/// ݃|CgĂs̎w̃^Cvǂ肷
	/**
	 * @param index `FbN̔ԍi0n܂j
	 * @return ȂtrueAłȂfalse
	 * @throw OutOfBoundsException index͈͂EĂꍇ
	 */
	bool isInt(int index);

	/// ݃|CgĂs̎w̃^Cvǂ肷
	/**
	 * @param index `FbN̔ԍi0n܂j
	 * @return ȂtrueAłȂfalse
	 * @throw OutOfBoundsException index͈͂EĂꍇ
	 */
	bool isReal(int index);

	/// ݃|CgĂs̎w̃^CvBLOBǂ肷
	/**
	 * @param index `FbN̔ԍi0n܂j
	 * @return BLOBȂtrueAłȂfalse
	 * @throw OutOfBoundsException index͈͂EĂꍇ
	 */
	bool isBlob(int index);

	/// ݃|CgĂs̎w̒l𕶎ƂĎ擾
	/**
	 * @param index ԍi0n܂j
	 * @return 擾l
	 * @throw OutOfBoundsException index͈͂EĂꍇ
	 */
	SqliteString valueAsStr(int index);

	/// ݃|CgĂs̎w̒l𐮐lƂĎ擾
	/**
	 * @param index ԍi0n܂j
	 * @return 擾l
	 * @throw OutOfBoundsException index͈͂EĂꍇ
	 */
	int valueAsInt(int index);

	/// ݃|CgĂs̎w̒l64bitlƂĎ擾
	/**
	 * @param index ԍi0n܂j
	 * @return 擾l
	 * @throw OutOfBoundsException index͈͂EĂꍇ
	 */
	__int64 valueAsInt64(int index);

	/// ݃|CgĂs̎w̒llƂĎ擾
	/**
	 * @param index ԍi0n܂j
	 * @return 擾l
	 * @throw OutOfBoundsException index͈͂EĂꍇ
	 */
	double valueAsReal(int index);

	/// BLOBl̐擪AhXԂ
	/**
	 * @param index ԍi0n܂j
	 * @return 擾AhX
	 * @throw OutOfBoundsException index͈͂EĂꍇ
	 */
	const void* valueAsBlob(int index);

	/// l߂oCgTCYԂB
	/**
	 * @param index ԍi0n܂j
	 * @return oCg
	 * @throw OutOfBoundsException index͈͂EĂꍇ
	 * @note lłꍇAUTF8ɕϊɃoCgTCYZoB
	 */
	int valueBytes(int index);

	/// l߂oCgTCYԂB
	/**
	 * @param index ԍi0n܂j
	 * @return oCg
	 * @throw OutOfBoundsException index͈͂EĂꍇ
	 * @note lłꍇAUTF16ɕϊɃoCgTCYZoB
	 */
	int valueBytes16(int index);

	/// w̖O擾
	/**
	 * @param index ԍ (0n܂j
	 * @return 
	 * @throw OutOfBoundsException index͈͂EĂꍇ
	 */
	SqliteString colName(int index);

protected:
	void checkResult(int rescode);

	void checkColIndex(int index, const char* reason);
};

/// SqliteCursorIuWFNgւ̃X}[g|C^
typedef SqliteSmartPtr<SqliteCursor> SqliteCursorPtr;


/// Xe[gg
class SqliteStatement
{
	friend class SqliteConnection;

protected:
	/// SQL
	SqliteString	m_sql;
	/// Xe[ggnh
	sqlite3_stmt*	m_stmt;
	/// SQLitef[^x[Xnh
	sqlite3*		m_db;

public:
	/// ێSQL擾
	SqliteString sql();

	/// Xe[ggnh擾
	sqlite3_stmt* stmt();

	/// f[^x[Xnh擾
	sqlite3* db();

protected:
	/// RXgN^BSqliteConnection݂̂p
	/**
	 * @param sql SQLBPrepared Statement邽߁AChJ[h"?"𗘗p\B
	 * @param stmt Xe[ggnh
	 * @param db f[^x[Xnh
	 */
	SqliteStatement(const _TCHAR* sql, sqlite3_stmt* stmt, sqlite3* db);

public:
	virtual ~SqliteStatement();

	/// xexecute, executeQueryXe[ggAĂexecuteł悤ɏԂZbg
	/**
	 * @throw QueryException ZbgɎsꍇ
	 * @note Prepared Statement̏ꍇAreset()ĂChJ[hɃoChꂽl͈ȑÔ܂܂łB
	 * KvȂAreset()ɍăoCh邱ƂłB
	 */
	void reset();

	/// ʂԂȂXe[ggsiINSERT, DELETE, UPDATE, CREATE TABLEȂǁj
	/**
	 * @throw QueryException sɎsꍇ
	 */
	void execute();

	/// Xe[ggsAʂ擾邽߂̃J[\Ԃ
	/**
	 * @return J[\IuWFNgւ̃|C^
	 * @note ̎_ł͗O𓊂ȂBSqliteCursor::next()œB
	 */
	SqliteCursor * executeQuery();

	/// Prepared Statement̃ChJ[hɁAۂ̒loCh
	/**
	 * @param index CfbNXi1n܂j
	 * @param val oChl
	 * @throw QueryException LȃCfbNX͈͂𒴉߂Ƃ
	 * @note ŏ̃ChJ[h̃CfbNX́A1ł邱ƂɒӁB
	 * 0ł͂ȂB܂ALȃCfbNX͈͂𒴉߂ƂɓOA
	 * OutOfBoundsExceptionł͂ȂAQueryExceptionł邱ƂɒӁB
	 *iSQLite{̂̃`FbN@\ɂ̂ł邽߁j
	 */
	void setParam(int index, int val);

	/// Prepared Statement̃ChJ[hɁAۂ̒loCh
	/**
	 * @param index CfbNXi1n܂j
	 * @param val oChl
	 * @throw QueryException LȃCfbNX͈͂𒴉߂Ƃ
	 * @note ŏ̃ChJ[h̃CfbNX́A1ł邱ƂɒӁB
	 * 0ł͂ȂB܂ALȃCfbNX͈͂𒴉߂ƂɓOA
	 * OutOfBoundsExceptionł͂ȂAQueryExceptionł邱ƂɒӁB
	 *iSQLite{̂̃`FbN@\ɂ̂ł邽߁j
	 */
	void setParam(int index, __int64 val);

	/// Prepared Statement̃ChJ[hɁAۂ̒loCh
	/**
	 * @param index CfbNXi1n܂j
	 * @param val oChl
	 * @throw QueryException LȃCfbNX͈͂𒴉߂Ƃ
	 * @note ŏ̃ChJ[h̃CfbNX́A1ł邱ƂɒӁB
	 * 0ł͂ȂB܂ALȃCfbNX͈͂𒴉߂ƂɓOA
	 * OutOfBoundsExceptionł͂ȂAQueryExceptionł邱ƂɒӁB
	 *iSQLite{̂̃`FbN@\ɂ̂ł邽߁j
	 */
	void setParam(int index, double val);

	/// Prepared Statement̃ChJ[hɁAۂ̒loCh
	/**
	 * @param index CfbNXi1n܂j
	 * @param val oChl
	 * @throw QueryException LȃCfbNX͈͂𒴉߂Ƃ
	 * @note ŏ̃ChJ[h̃CfbNX́A1ł邱ƂɒӁB
	 * 0ł͂ȂB܂ALȃCfbNX͈͂𒴉߂ƂɓOA
	 * OutOfBoundsExceptionł͂ȂAQueryExceptionł邱ƂɒӁB
	 *iSQLite{̂̃`FbN@\ɂ̂ł邽߁j
	 */
	void setParam(int index, const _TCHAR* val);

	/// Prepared Statement̃ChJ[hɁAۂ̒loCh
	/**
	 * @param index CfbNXi1n܂j
	 * @param val oChl
	 * @param nBytes BLOB̃oCg
	 * @param makeCopy BLOBRs[ĕێꍇɂtrue
	 * @throw QueryException LȃCfbNX͈͂𒴉߂Ƃ
	 * @note ŏ̃ChJ[h̃CfbNX́A1ł邱ƂɒӁB
	 * 0ł͂ȂB܂ALȃCfbNX͈͂𒴉߂ƂɓOA
	 * OutOfBoundsExceptionł͂ȂAQueryExceptionł邱ƂɒӁB
	 *iSQLite{̂̃`FbN@\ɂ̂ł邽߁j
	 */
	void setParam(int index, const void* val, int nBytes, bool makeCopy=true);

protected:
	void checkResult(int rescode);
};

/// SqliteStatementIuWFNgւ̃X}[g|C^
typedef SqliteSmartPtr<SqliteStatement> SqliteStatementPtr;


}; //end of namespace sqlite3plus


#endif SqliteStatement_H
