use strict;
use utf8;
use Encode;

my $TDFFile = 'revisioninfo.tdf';

# usage: $0  #.#.#.#level  "TVP version"
my ($TPVersion, $TVPVersion) = ($ARGV[0] || 'unknown', $ARGV[1] || 'not specified');

$TPVersion =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)(.*)/;
my ($major, $minor, $release, $build, $level) = ($1, $2, $3, $4, $5);
$release = '' unless ($release);
my $dispver = "${major}.${minor} ${level}${release}";

my $out = << "EOF";
UL
LI* lib/tp_utils-${TPVersion}-TVP${TVPVersion}.zip 吉里吉里２ ${TVPVersion}用バイナリ （ver. ${dispver}）
LI* lib/doc-tp_utils-${TPVersion}-TVP${TVPVersion}.zip マニュアル一式 （ver. ${dispver}）
LI* lib/src-tp_utils-${TPVersion}-TVP${TVPVersion}.zip ソース一式 （ver. ${dispver}）
/UL
EOF


open FH, ">$TDFFile";
print FH (Encode::encode('shiftjis', $out));
close(FH);



