use strict;
use utf8;
use Encode;

my %Synopsys = (
	'system'  => 'System',
	'generic' => 'Generic',
	'io'      => 'I/O',
	'graph'   => 'Graphic',
	'sqlite'  => 'SQLite',
	'iconv'   => 'ICONV',
);

my $NUL = '\\0';
my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime();
$year += 1900;

my ($name, $major, $minor, $release, $build) = @ARGV;
my $synop = ($name =~ /util_(.*)\.dll/) ? $Synopsys{$1} : '';
my $copyright = "Copyright 2004-$year mey";

# language
# 0411 : Japanese
my $lang = 0x0411;

# translation
# 1200 : UTF8
#  932 : CP932
my $trans = 932;
my $blockid = sprintf('%04X%04X', $lang, $trans);


$name    ||= 'Noname';
$synop   ||= 'Unknown';
$major   ||= 0;
$minor   ||= 0;
$release ||= 0;
$build   ||= 0;


my $out = << "EOF";
//-----------------------------
// generated by $0
//-----------------------------
VS_VERSION_INFO     VERSIONINFO
  FILEVERSION       $major, $minor, $release, $build
  PRODUCTVERSION    $major, $minor, $release, $build
  FILEFLAGSMASK     VS_FFI_FILEFLAGSMASK
  FILEFLAGS         0
  FILEOS            VOS_DOS_WINDOWS32
  FILETYPE          VFT_DLL
  FILESUBTYPE       VFT2_UNKNOWN
BEGIN
    BLOCK "StringFileInfo"
    BEGIN
        BLOCK "$blockid"
        BEGIN
           VALUE "FileVersion",      "$major.$minor.$release.$build$NUL"
           VALUE "FileDescription",  "Plugin for Kirikiri2/win32$NUL"
           VALUE "LegalCopyright",   "$copyright$NUL"
//         VALUE "Comments",         "$NUL"
//         VALUE "CompanyName",      "Unknown Corp.$NUL"
//         VALUE "LegalTrademarks",  "$NUL"
           VALUE "OriginalFilename", "$name$NUL"
           VALUE "ProductVersion",   "$major.$minor.$release.$build$NUL"
           VALUE "ProductName",      "ごった煮プラグイン ($synop)$NUL"
//         VALUE "InternalName",     "tvp2/win32 $NUL"
//         VALUE "PrivateBuild",     "$NUL"
//         VALUE "SpecialBuild",     "$NUL"
        END
    END
    BLOCK "VarFileInfo"
    BEGIN
        VALUE "Translation", $lang, $trans
    END
END

// アイコン
//TVP_PLUGIN_ICON32 ICON DISCARDABLE "..\\common\\TVPPlugin32.ico"
//TVP_PLUGIN_ICON48 ICON DISCARDABLE "..\\common\\TVPPlugin48.ico"

EOF



print Encode::encode('shift_jis', $out);
